

#define ADR_BASE_SCREEN         48000 
#define HIRES_SCREEN_ADDRESS    0xA000
#define NB_LESS_LINES_4_COLOR   4

#define HIRES_50Hz   30
#define TEXT_50Hz    26

#define INK_BLACK    0
#define INK_RED      1
#define INK_GREEN    2
#define INK_YELLOW   3
#define INK_BLUE     4
#define INK_MAGENTA  5
#define INK_CYAN     6
#define INK_WHITE    7


unsigned char tab_color [] = {INK_CYAN, INK_YELLOW, INK_MAGENTA, INK_BLUE, INK_GREEN, INK_RED, INK_CYAN, INK_YELLOW} ;

void prepare_colors() {
    int ii, jj;

    for (ii = 0; ii<SCREEN_HEIGHT-NB_LESS_LINES_4_COLOR ; ii++){
        poke (ADR_BASE_SCREEN+(ii*SCREEN_WIDTH)+0,HIRES_50Hz);
        fbuffer[ii*SCREEN_WIDTH]=HIRES_50Hz;
        for (jj = 0; jj < 8; jj++) {
            poke (HIRES_SCREEN_ADDRESS+((ii*8+jj)*SCREEN_WIDTH)+1, 
                tab_color[jj] // peek(HIRES_SCREEN_ADDRESS+((ii*8+jj)*SCREEN_WIDTH)+1)&0x07 // 
            );
            poke (HIRES_SCREEN_ADDRESS+((ii*8+jj)*SCREEN_WIDTH)+2, TEXT_50Hz);
        }
    }
    for (; ii<SCREEN_HEIGHT ; ii++){
        poke (ADR_BASE_SCREEN+(ii*SCREEN_WIDTH)+0,TEXT_50Hz);
        fbuffer[ii*SCREEN_WIDTH]=TEXT_50Hz;
    }
}
