#ifdef __GNUC__

#ifdef USE_NCURSES

#include "ncursesw/ncurses.h"

#else //  Not USE_NCURSES

#include <conio.h>

#endif //  USE_NCURSES

#include <stdio.h>
#include <string.h>
#include <unistd.h>  /* only for sleep() */
#include "oric.c"
#define USE_C_GLORIC
#undef USE_ASM_GLORIC
#undef USE_COLOR

#define  USE_C_SHAPELOADER_DATA
#define USE_C_SHAPELOADER

unsigned char 	kernel_cs=0;
unsigned char 	kernel_s=0;
unsigned char 	kernel_fraction=0;
unsigned char 	kernel_beat=0;
unsigned char 	kernel_tempo=0;

int getTempo() {return 120;}

#else // Not __GNUC__ 

#undef USE_NCURSES
#include <lib.h>
#undef USE_C_GLORIC
#define USE_ASM_GLORIC
#define USE_COLOR
#define USE_ASM_SHAPELOADER_DATA
#define USE_ASM_SHAPELOADER
#define USE_MUSIC

extern unsigned char 	kernel_cs;
extern unsigned char 	kernel_s;
extern unsigned char 	kernel_fraction;
extern unsigned char 	kernel_beat;
extern unsigned char 	kernel_tempo;



#endif // __GNUC__ 

#ifdef __GNUC__
#ifndef USE_NCURSES
char screen_buffer[SCREEN_WIDTH * SCREEN_HEIGHT];
#endif
#endif // __GNUC__ 

#define USE_C_MULTI40
#define USE_C_EXP_DATA



/*
 * Math operators 
 */
#ifdef __GNUC__
// ATAN2 : 874 bytes more for C version
#define USE_C_ATAN2
#undef USE_ASM_ATAN2

// NORM : 1000 bytes more for C version
#define USE_C_NORM
#undef USE_ASM_NORM

// EXP : 245 bytes more for C version
#define USE_C_EXP
#undef USE_ASM_EXP

#define USE_C_RAYCASTING_DATA
#undef USE_ASM_RAYCASTING_DATA
#define USE_C_RAYCASTING
#undef USE_ASM_RAYCASTING
#define USE_C_TOTO
#undef USE_ASM_TOTO
#define USE_C_PREDRAW
#undef USE_ASM_PREDRAW

char             fbuffer[SCREEN_WIDTH * SCREEN_HEIGHT];  // frame buffer 
void AdvancedPrint(char x_pos,char y_pos,const char *ptr_message){;} // TODO

#else


#undef USE_C_ATAN2
#define USE_ASM_ATAN2

#undef USE_C_NORM
#define USE_ASM_NORM

#undef USE_C_EXP
#define USE_ASM_EXP

#undef USE_C_RAYCASTING_DATA
#define USE_ASM_RAYCASTING_DATA
#undef USE_C_RAYCASTING
#define USE_ASM_RAYCASTING
#define USE_ASM_TOTO
#undef USE_C_TOTO
#undef USE_C_PREDRAW
#define USE_ASM_PREDRAW
// Render buffer
extern char             fbuffer[];  // frame buffer SCREEN_WIDTH * SCREEN_HEIGHT
#endif

#define USE_C_LOG2
#undef USE_C_COSSIN

// Raycasting configuration 
#define USE_RAYCASTING
#define USE_ANTIFISH
#define USE_DISTANCE2HIRESHEIGHT
#define ROT_ANGLE_STEP 16

#define USE_GLORIC

#include "tables.c"

#define USE_C_PRINT_TEXT
#include "text.c"
#include "system.c"
#include "math.c"


#include "textures.c"
#include "colors.c"

#ifdef USE_GLORIC

#ifdef USE_ASM_GLORIC
#include "glOric.h"
#endif // USE_GLORIC

#ifdef USE_C_GLORIC
#include "glOric_c.c"
#endif // USE_C_GLORIC

#include "glScene.c"

#endif // USE_GLORIC



#ifdef USE_RAYCASTING
#include "ray_c.c"
#include "rayScene.c"
signed char* sceneData;
#endif 


#include "render.c"

#include "engine_objects.c"
#include "engine.c"
#include "player.c"

#define CURSOR_START 10 // #26a,10
#define CURSOR_END 3 // #26a,3
