// Inpired by Rax https://github.com/raxrax/oricAsciiTank
#define OBJECTS_MAX 18

struct objectStruct
{
    unsigned char type;
    unsigned char active;
    signed char x;
    signed char y;
    char *data;
};


static unsigned char       engCurrentObjectIdx;
static struct objectStruct engObjects[OBJECTS_MAX];

// objects
#define OBJ_EMPTY 1
#define OBJ_FISH 2

void emptyUpdate();
void fishUpdate();

#ifdef USE_AUTOPILOT
#define OBJ_CAMERA 3
void cameraUpdate();
#endif // USE_AUTOPILOT


void engObjectPulse()
{
    switch (engObjects[engCurrentObjectIdx].type)
    {
#ifdef USE_AUTOPILOT
        case OBJ_CAMERA:
            cameraUpdate();
            break;
#endif // USE_AUTOPILOT
        case OBJ_EMPTY:
            emptyUpdate();
            break;
        case OBJ_FISH:
            fishUpdate();
            break;
    }
}

#define LRG_BLOCK_DIV2 3

void emptyUpdate()
{
    static char sensEmpty = 1;
	unsigned char ex = engObjects[engCurrentObjectIdx].x;
    unsigned char ey = engObjects[engCurrentObjectIdx].y;
    //engObjects[engCurrentObjectIdx].data[0];
    // printText(engObjects[engCurrentObjectIdx].data,ex, ey);
    // glNbVertices     = 0;
    // glNbSegments   = 0;
    // glNbFaces      = 0;
    // glNbParticles = 0;

    // addGeom(12, -12, 3, 1, 1, 1, 0, geomHouse);
    // addGeom(24, 12, 0, 1, 1, 1, 0, geomPine);
    // addGeom(24, -24, 0, 1, 1, 1, 0, geomTower);

    ex = (ex+sensEmpty);
    if ((ex == 40) || (ex == 0)){
        sensEmpty = -sensEmpty; 
    }

	// , 13, 19		// P4
	// , 25, 19		// P5
	// , 25, 27		// P6
	// , 13, 27		// P7

    // lPointsX[0]=ex - LRG_BLOCK;
    // lPointsY[0]=ey - LRG_BLOCK;
    // lPointsX[1]=ex + LRG_BLOCK;
    // lPointsY[1]=ey - LRG_BLOCK;
    // lPointsX[2]=ex + LRG_BLOCK;
    // lPointsY[2]=ey + LRG_BLOCK;
    // lPointsX[3]=ex - LRG_BLOCK;
    // lPointsY[3]=ey + LRG_BLOCK;

    lPointsX[4]=-(ex - LRG_BLOCK_DIV2);
    lPointsY[4]=-(ey - LRG_BLOCK_DIV2);
    lPointsX[5]=-(ex + LRG_BLOCK_DIV2);
    lPointsY[5]=-(ey - LRG_BLOCK_DIV2);
    lPointsX[6]=-(ex + LRG_BLOCK_DIV2);
    lPointsY[6]=-(ey + LRG_BLOCK_DIV2);
    lPointsX[7]=-(ex - LRG_BLOCK_DIV2);
    lPointsY[7]=-(ey + LRG_BLOCK_DIV2);

    engObjects[engCurrentObjectIdx].x = ex;
    engObjects[engCurrentObjectIdx].y = ey;
}

void fishUpdate()
{
    static char sensFish = 1;
	unsigned char ex = engObjects[engCurrentObjectIdx].x;
    unsigned char ey = engObjects[engCurrentObjectIdx].y;

    // printText("F",ex, ey);
    ey = (ey+sensFish);
    if ((ey == 26) || (ey == 0)){
        sensFish = -sensFish; 
    }
	// , 55, 19		// P8
	// , 65, 19		// P9
	// , 65, 27		// P10
	// , 55, 27		// P11

    lPointsX[8 ]=-(ex - LRG_BLOCK_DIV2);
    lPointsY[8 ]=-(ey - LRG_BLOCK_DIV2);
    lPointsX[9 ]=-(ex + LRG_BLOCK_DIV2);
    lPointsY[9 ]=-(ey - LRG_BLOCK_DIV2);
    lPointsX[10]=-(ex + LRG_BLOCK_DIV2);
    lPointsY[10]=-(ey + LRG_BLOCK_DIV2);
    lPointsX[11]=-(ex - LRG_BLOCK_DIV2);
    lPointsY[11]=-(ey + LRG_BLOCK_DIV2);
   
    engObjects[engCurrentObjectIdx].x = ex;
    engObjects[engCurrentObjectIdx].y = ey;
}

void engInitObjects()
{
    unsigned char i;
    for (i = 0; i < OBJECTS_MAX; i++) engObjects[i].active = 0;

}

void engAddObject(char type, unsigned char x, unsigned char y, char *data)
{
    unsigned char i;
    for (i = 0; i < OBJECTS_MAX; i++)
    {
        if (engObjects[i].active == 0)
        {
            engObjects[i].active = 1;
            engObjects[i].type = type;
            engObjects[i].x = x;
            engObjects[i].y = y;
            engObjects[i].data = data;
            return;
        }
    }
}

void engDeleteObject(unsigned char objectNumber) {
    engObjects[objectNumber].active = 0;
}

void engDeleteAllObjects(unsigned char objectType) {
    unsigned char i;
    for (i = 0; i < OBJECTS_MAX; i++)
        if (1 == engObjects[i].active && objectType == engObjects[i].type)
            engObjects[i].active = 0;
}

#ifdef USE_AUTOPILOT
void cameraUpdate()
{
    static char sensCamera = 3;
	signed char ex = engObjects[engCurrentObjectIdx].x;
    signed char ey = engObjects[engCurrentObjectIdx].y;
    //engObjects[engCurrentObjectIdx].data[0];
    // printText(engObjects[engCurrentObjectIdx].data,ex, ey);

    // ex = (ex+sensCamera);
    ey = (ey+sensCamera);

    if ((ey > 64) || (ey <= -64)){
        sensCamera = -sensCamera; 
    }


    glCamPosX       = ex;
    glCamPosY       = ey;
    rayCamPosX      = ex;
    rayCamPosY      = ey;

    // lPointsX[4]=ex - LRG_BLOCK_DIV2;
    // lPointsY[4]=ey - LRG_BLOCK_DIV2;
    // lPointsX[5]=ex + LRG_BLOCK_DIV2;
    // lPointsY[5]=ey - LRG_BLOCK_DIV2;
    // lPointsX[6]=ex + LRG_BLOCK_DIV2;
    // lPointsY[6]=ey + LRG_BLOCK_DIV2;
    // lPointsX[7]=ex - LRG_BLOCK_DIV2;
    // lPointsY[7]=ey + LRG_BLOCK_DIV2;

    engObjects[engCurrentObjectIdx].x = ex;
    engObjects[engCurrentObjectIdx].y = ey;
}
#endif // USE_AUTOPILOT
