
#define ANGLE_VIEW 0xE0
#define DOLLAR 36
#define ADR_BASE_LORES_SCREEN 48040 

#define ANGLE_MAX 0xC0


#define  USE_C_INITFRAMEBUFFER
#define  USE_C_ZPLOT
#define  USE_C_ARRAYSPROJECT
#define  USE_C_GLDRAWFACES 
#define  USE_C_GLDRAWSEGMENTS
#define USE_C_RETRIEVEFACEDATA
#define USE_C_SORTPOINTS
#define USE_C_FILLFACE
#define USE_C_GUESSIFFACE2BEDRAWN
#define USE_C_SORTPOINTS
#define USE_C_DRAWLINE
#define USE_C_ANGLE2SCREEN
#define USE_C_FILL8
#define USE_C_ISA1RIGHT1
#define USE_C_ISA1RIGHT3

#define USE_SATURATION
#define USE_C_BRESTYPE1
#define USE_C_BRESTYPE2
#define USE_C_BRESTYPE3
#define USE_C_AGENTSTEP
#define USE_C_RETRIEVEFACEDATA

#define USE_C_BRESFILL
#define USE_C_REACHSCREEN
#define USE_C_SWITCH_A2XSATUR
#define USE_C_SWITCH_A1XSATUR
#define USE_C_INITSATUR_A1LEFT
#define USE_C_INITSATUR_A1RIGHT

#define USE_C_HZFILL
#define USE_C_PLOT

#define USE_C_BUFFER2SCREEN
#define USE_C_GLDRAWPARTICLES
#define USE_C_GLPROJECTPOINT

 // Camera Position use only low bytes
signed char              glCamPosX;
signed char              glCamPosY;
signed char              glCamPosZ;

 // Camera Orientation
char             glCamRotZ;  // -128 -> 127 unit : 2PI/(2^8 - 1)
char             glCamRotX;

 // Geometry size
unsigned char    glNbVertices;
unsigned char    glNbFaces;
unsigned char    glNbSegments;
unsigned char    glNbParticles;

#define NB_MAX_VERTICES 32
#define NB_MAX_SEGMENTS 16
#define NB_MAX_FACES 24
#define NB_MAX_PARTICLES 8


 // Geometry buffers
signed char      glVerticesX[NB_MAX_VERTICES];
signed char      glVerticesY[NB_MAX_VERTICES];
signed char      glVerticesZ[NB_MAX_VERTICES];
unsigned char    glParticlesPt[NB_MAX_PARTICLES];
unsigned char    glParticlesChar[NB_MAX_PARTICLES];
unsigned char    glSegmentsPt1[NB_MAX_SEGMENTS];
unsigned char    glSegmentsPt2[NB_MAX_SEGMENTS];
unsigned char    glSegmentsChar[NB_MAX_SEGMENTS];
unsigned char    glFacesPt1[NB_MAX_FACES];
unsigned char    glFacesPt2[NB_MAX_FACES];
unsigned char    glFacesPt3[NB_MAX_FACES];
unsigned char    glFacesChar[NB_MAX_FACES];

// Render buffer
char             fbuffer[SCREEN_WIDTH * SCREEN_HEIGHT];  // frame buffer SCREEN_WIDTH * SCREEN_HEIGHT
unsigned char    zbuffer[SCREEN_WIDTH * SCREEN_HEIGHT];  // z-depth buffer


signed char points2aH[NB_MAX_VERTICES];
signed char points2aV[NB_MAX_VERTICES];
unsigned char points2dH[NB_MAX_VERTICES];
unsigned char points2dL[NB_MAX_VERTICES];

// fillface
signed char   P1X, P1Y, P2X, P2Y, P3X, P3Y;
signed char   P1AH, P1AV, P2AH, P2AV, P3AH, P3AV;
unsigned char distface;
char          ch2disp;
signed char pDepX;
signed char pDepY;
signed char pArr1X;
signed char pArr1Y;
signed char pArr2X;
signed char pArr2Y;
unsigned char distface;
unsigned char distseg;
int           dmoy;

unsigned char idxPt1, idxPt2, idxPt3;
int           d1, d2, d3;
unsigned char isFace2BeDrawn;
unsigned char m1, m2, m3;
unsigned char v1, v2, v3;
signed char mDeltaY1, mDeltaX1, mDeltaY2, mDeltaX2;



signed char A1X;
signed char A1Y;
signed char A1destX;
signed char A1destY;
signed char A1dX;
signed char A1dY;
signed char A1err;
signed char A1sX;
signed char A1sY;
char        A1arrived;
signed char A2X;
signed char A2Y;
signed char A2destX;
signed char A2destY;
signed char A2dX;
signed char A2dY;
signed char A2err;
signed char A2sX;
signed char A2sY;
char        A2arrived;
unsigned char A1Right;

#ifdef USE_SATURATION
unsigned char A1XSatur;
unsigned char A2XSatur;
#endif // USE_SATURATION

unsigned char lineIndex;
unsigned char departX;
unsigned char finX;
signed char hLineLength;

void glProjectArrays();
void glDrawFaces();
void glDrawSegments();
void glDrawParticles();
void glInitScreenBuffers();
void glBuffer2Screen();
void glZPlot(signed char X, signed char Y, unsigned char dist, char char2disp);
void glProjectPoint(signed char x, signed char y, signed char z, unsigned char options, signed char *ah, signed char *av, unsigned int *dist);
// extern void glProject (char points2D[], char points3D[], unsigned char nbVertices, unsigned char options);

void sortPoints();
void retrieveFaceData();
void guessIfFace2BeDrawn ();
void fillFace();
void lrDrawLine();
void angle2screen();
void fill8();
void isA1Right1 ();
void isA1Right3 ();
void prepare_bresrun();
void bresStepType1();
void bresStepType2();
void bresStepType3();

void reachScreen();
void initSatur_A1Left ();
void initSatur_A1Right ();

void A2stepY_A1Left();
void A1stepY_A1Left();
void A2stepY_A1Right();
void A1stepY_A1Right();

void hzfill();

void A2stepY();
void A1stepY();


void plot(signed char X,
           signed char Y,
           char          char2disp);

#ifdef USE_C_INITFRAMEBUFFER
void glInitScreenBuffers() {
#ifdef USE_COLOR
    int ii, jj;
#endif
    memset(zbuffer, 0xFF, SCREEN_WIDTH * SCREEN_HEIGHT);
    
#ifdef USE_COLOR
    for (ii=0; ii< SCREEN_HEIGHT; ii++){
        for (jj=3; jj< SCREEN_WIDTH; jj++){
            fbuffer[ii*SCREEN_WIDTH+jj] = 0x20;
        }
    }
#else
    memset(fbuffer, 0x20, SCREEN_WIDTH * SCREEN_HEIGHT);  // Space
#endif
}
#endif // USE_C_INITFRAMEBUFFER


#ifdef USE_C_ZPLOT

void glZPlot(signed char X,
           signed char Y,
           unsigned char dist,
           char          char2disp) {
    int            offset;
    char*          ptrFbuf;
    unsigned char* ptrZbuf;

#ifdef USE_COLOR
    if ((Y <= 0) || (Y >= SCREEN_HEIGHT-NB_LESS_LINES_4_COLOR) || (X <= 2) || (X >= SCREEN_WIDTH))
        return;
#else
    if ((Y <= 0) || (Y >= SCREEN_HEIGHT) || (X <= 0) || (X >= SCREEN_WIDTH))
        return;
#endif

#ifdef USE_MULTI40
    offset = multi40[Y] + X;  // 
#else
    offset = Y*SCREEN_WIDTH+X; 
#endif

    ptrZbuf = zbuffer + offset;
    ptrFbuf = fbuffer + offset;

    // printf ("pl [%d %d] zbuff = %d , pointDist = %d\n", X, Y, *ptrZbuf, dist);
    if (dist < *ptrZbuf) {
        *ptrFbuf = char2disp;
        *ptrZbuf = dist;
    }
}

#endif


#ifdef USE_C_ARRAYSPROJECT
void glProjectArrays(){
    unsigned char ii;
    signed char x, y, z;
    signed char ah, av;
    unsigned int dist ;
    unsigned char options=0;

    for (ii = 0; ii < glNbVertices; ii++){
        x = glVerticesX[ii];
        y = glVerticesY[ii];
        z = glVerticesZ[ii];

        glProjectPoint(x, y, z, options, &ah, &av, &dist);

        points2aH[ii] = ah;
        points2aV[ii] = av;
        points2dH[ii] = (signed char)((dist & 0xFF00)>>8) && 0x00FF;
        points2dL[ii] = (signed char) (dist & 0x00FF);

    }
}
#endif // USE_C_ARRAYSPROJECT

#ifdef USE_C_GLDRAWFACES 

void glDrawFaces() {
    unsigned char ii = 0;

    // printf ("%d Points, %d Segments, %d Faces\n", glNbVertices, glNbSegments, glNbFaces); get();
    for (ii = 0; ii < glNbFaces; ii++) {

        idxPt1 = glFacesPt1[ii] ;
        idxPt2 = glFacesPt2[ii] ;
        idxPt3 = glFacesPt3[ii] ;
        ch2disp = glFacesChar[ii];

        retrieveFaceData();
        // printf ("P1 [%d, %d], P2 [%d, %d], P3 [%d %d]\n", P1AH, P1AV, P2AH, P2AV,  P3AH, P3AV); get();


        sortPoints();



        guessIfFace2BeDrawn();
        if (isFace2BeDrawn) {
            fillFace();
        }
    }
}

#endif // USE_C_GLDRAWFACES 


#ifdef USE_C_GLDRAWSEGMENTS
void glDrawSegments() {
    unsigned char ii = 0;

    for (ii = 0; ii < glNbSegments; ii++) {

        idxPt1    = glSegmentsPt1[ii];
        idxPt2    = glSegmentsPt2[ii];
        ch2disp = glSegmentsChar[ii];

        // dmoy = (d1+d2)/2;

#ifdef ANGLEONLY
        P1AH = points2aH[idxPt1];
        P1AV = points2aV[idxPt1];
#else 
        P1X = points2aH[idxPt1];
        P1Y = points2aV[idxPt1];
#endif
        dmoy = points2dL[idxPt1];


#ifdef ANGLEONLY
        P2AH = points2aH[idxPt2];
        P2AV = points2aV[idxPt2];
#else 
        P2X = points2aH[idxPt2];
        P2Y = points2aV[idxPt2];
#endif        
        dmoy += points2dL[idxPt2];

        dmoy = dmoy >> 1;
        

        //if (dmoy >= 256) {
        if ((dmoy & 0xFF00) != 0)
            continue;
        distseg = (unsigned char)((dmoy)&0x00FF);
        distseg--;  // FIXME

#ifdef ANGLEONLY
        P1X = (SCREEN_WIDTH - P1AH) >> 1;
        P1Y = (SCREEN_HEIGHT - P1AV) >> 1;
        P2X = (SCREEN_WIDTH - P2AH) >> 1;
        P2Y = (SCREEN_HEIGHT - P2AV) >> 1;
#endif
        // printf ("dl ([%d, %d] , [%d, %d] => %d c=%d\n", P1X, P1Y, P2X, P2Y, distseg, ch2disp); waitkey();
        lrDrawLine();
    }

}

#endif // USE_C_GLDRAWSEGMENTS

#ifdef USE_C_RETRIEVEFACEDATA
void retrieveFaceData(){

        // printf ("face %d : %d %d %d\n",ii, idxPt1, idxPt2, idxPt3);get();
        dmoy = points2dL[idxPt1]; //*((int*)(points2d + offPt1 + 2));
        P1AH = points2aH[idxPt1];
        P1AV = points2aV[idxPt1];

        dmoy += points2dL[idxPt2]; //*((int*)(points2d + offPt2 + 2));
        P2AH = points2aH[idxPt2];
        P2AV = points2aV[idxPt2];

        dmoy +=  points2dL[idxPt3]; //*((int*)(points2d + offPt3 + 2));
        P3AH = points2aH[idxPt3];
        P3AV = points2aV[idxPt3];

        // printf ("dis %d %d %d\n",d1, d2, d3);get();
        dmoy = dmoy / 3;
        if (dmoy >= 256) {
            dmoy = 256;
        }
        distface = (unsigned char)(dmoy & 0x00FF);

        // printf ("disface %d %d\n",dmoy, distface);get();

}
#endif // USE_C_RETRIEVEFACEDATA

#ifdef USE_C_SORTPOINTS
void sortPoints(){
    signed char   tmpH, tmpV;
    if (abs(P2AH) < abs(P1AH)) {
        tmpH = P1AH;
        tmpV = P1AV;
        P1AH = P2AH;
        P1AV = P2AV;
        P2AH = tmpH;
        P2AV = tmpV;
    }
    if (abs(P3AH) < abs(P1AH)) {
        tmpH = P1AH;
        tmpV = P1AV;
        P1AH = P3AH;
        P1AV = P3AV;
        P3AH = tmpH;
        P3AV = tmpV;
    }
    if (abs(P3AH) < abs(P2AH)) {
        tmpH = P2AH;
        tmpV = P2AV;
        P2AH = P3AH;
        P2AV = P3AV;
        P3AH = tmpH;
        P3AV = tmpV;
    }
}
#endif // USE_C_SORTPOINTS

#ifdef USE_C_GUESSIFFACE2BEDRAWN
void guessIfFace2BeDrawn () {

    m1 = P1AH & ANGLE_MAX;
    m2 = P2AH & ANGLE_MAX;
    m3 = P3AH & ANGLE_MAX;
    v1 = P1AH & ANGLE_VIEW;
    v2 = P2AH & ANGLE_VIEW;
    v3 = P3AH & ANGLE_VIEW;

    isFace2BeDrawn = 0;
    if ((m1 == 0x00) || (m1 == ANGLE_MAX)) {
        if ((v1 == 0x00) || (v1 == ANGLE_VIEW)) {
            if (
                (
                    (P1AH & 0x80) != (P2AH & 0x80)) ||
                ((P1AH & 0x80) != (P3AH & 0x80))) {
                if ((abs(P3AH) < 127 - abs(P1AH))) {
                    isFace2BeDrawn=1;
                }
            } else {
                isFace2BeDrawn=1;
            }
        } else {
            // P1 FRONT
            if ((m2 == 0x00) || (m2 == ANGLE_MAX)) {
                // P2 FRONT
                if ((m3 == 0x00) || (m3 == ANGLE_MAX)) {
                    // P3 FRONT
                    // _4_
                    if (((P1AH & 0x80) != (P2AH & 0x80)) || ((P1AH & 0x80) != (P3AH & 0x80))) {
                        isFace2BeDrawn=1;
                    } else {
                        // nothing to do
                    }
                } else {
                    // P3 BACK
                    // _3_
                    if ((P1AH & 0x80) != (P2AH & 0x80)) {
                        if (abs(P2AH) < 127 - abs(P1AH)) {
                            isFace2BeDrawn=1;
                        }
                    } else {
                        if ((P1AH & 0x80) != (P3AH & 0x80)) {
                            if (abs(P3AH) < 127 - abs(P1AH)) {
                                isFace2BeDrawn=1;
                            }
                        }
                    }

                    if ((P1AH & 0x80) != (P3AH & 0x80)) {
                        if (abs(P3AH) < 127 - abs(P1AH)) {
                            isFace2BeDrawn=1;
                        }
                    }
                }
            } else {
                // P2 BACK
                // _2_ nothing to do
                if ((P1AH & 0x80) != (P2AH & 0x80)) {
                    if (abs(P2AH) < 127 - abs(P1AH)) {
                        isFace2BeDrawn=1;
                    }
                } else {
                    if ((P1AH & 0x80) != (P3AH & 0x80)) {
                        if (abs(P3AH) < 127 - abs(P1AH)) {
                            isFace2BeDrawn=1;
                        }
                    }
                }

                if ((P1AH & 0x80) != (P3AH & 0x80)) {
                    if (abs(P3AH) < 127 - abs(P1AH)) {
                        isFace2BeDrawn=1;
                    }
                }
            }
        }
    } else {
        // P1 BACK
        // _1_ nothing to do
    }
}
#endif // USE_C_GUESSIFFACE2BEDRAWN

#ifdef USE_C_FILLFACE
void fillFace() {
    angle2screen();

    // printf ("P1A: [%d, %d], P2A: [%d, %d], P3A [%d, %d]\n", P1AH, P1AV, P2AH, P2AV, P3AH, P3AV);
    // printf ("P1:[%d, %d], P2:[%d, %d], P3[%d, %d]\n", P1X, P1Y, P2X, P2Y, P3X, P3Y);waitkey();
    // printf ("distface = %d char = %d\n",distface, ch2disp);
    // get();

// #ifdef USE_PROFILER
//             PROFILE_ENTER(ROUTINE_FILL8);
// #endif
    fill8();
// #ifdef USE_PROFILER
//             PROFILE_LEAVE(ROUTINE_FILL8);
// #endif
}
#endif // USE_C_FILLFACE

#ifdef USE_C_DRAWLINE
void lrDrawLine() {

    signed char e2;
    char        ch2dsp;

    A1X     = P1X;
    A1Y     = P1Y;
    A1destX = P2X;
    A1destY = P2Y;
    A1dX    = abs(P2X - P1X);
    A1dY    = -abs(P2Y - P1Y);
    A1sX    = P1X < P2X ? 1 : -1;
    A1sY    = P1Y < P2Y ? 1 : -1;
    A1err   = A1dX + A1dY;

    if ((A1err > 64) || (A1err < -63))
        return;

    if ((ch2disp == '/') && (A1sX == -1)) {
        ch2dsp = DOLLAR;
    } else {
        ch2dsp = ch2disp;
    }

    while (1) {  // loop
        // printf ("plot [%d, %d] %d %d\n", A1X, A1Y, distseg, ch2disp);waitkey ();          
#ifdef USE_ZBUFFER
        glZPlot(A1X, A1Y, distseg, ch2dsp);
#else
        plot(A1X, A1Y, ch2dsp);
#endif
        if ((A1X == A1destX) && (A1Y == A1destY))
            break;
        //e2 = 2*err;
        e2 = (A1err < 0) ? (
                ((A1err & 0x40) == 0) ? (
                                                0x80)
                                        : (
                                            A1err << 1))
            : (
                ((A1err & 0x40) != 0) ? (
                                                0x7F)
                                        : (
                                                A1err << 1));
        if (e2 >= A1dY) {
            A1err += A1dY;  // e_xy+e_x > 0
            A1X += A1sX;
        }
        if (e2 <= A1dX) {  // e_xy+e_y < 0
            A1err += A1dX;
            A1Y += A1sY;
        }
    }
}
#endif // USE_C_DRAWLINE

#ifdef USE_C_ANGLE2SCREEN
void angle2screen() {
    P1X = (SCREEN_WIDTH - P1AH) >> 1;
    P1Y = (SCREEN_HEIGHT - P1AV) >> 1;
    P2X = (SCREEN_WIDTH - P2AH) >> 1;
    P2Y = (SCREEN_HEIGHT - P2AV) >> 1;
    P3X = (SCREEN_WIDTH - P3AH) >> 1;
    P3Y = (SCREEN_HEIGHT - P3AV) >> 1;
}
#endif  // USE_C_ANGLE2SCREEN

#ifdef USE_C_FILL8
void fill8() {

    prepare_bresrun();

    // printf ("Dep = [%d, %d], Arr1 = [%d, %d], Arr2= [%d, %d]\n", pDepX,pDepY, pArr1X, pArr1Y, pArr2X, pArr2Y);waitkey();
    if (pDepY != pArr1Y) {
        //a1 = bres_agent(pDep[0],pDep[1],pArr1[0],pArr1[1])
        //a2 = bres_agent(pDep[0],pDep[1],pArr2[0],pArr2[1])
        A1X     = pDepX;
        A2X     = pDepX;
        A1Y     = pDepY;
        A2Y     = pDepY;

        A1destX = pArr1X;
        A1destY = pArr1Y;
        A1dX    = abs(A1destX - A1X);
        A1dY    = -abs(A1destY - A1Y);
        A1err   = A1dX + A1dY;
        if ((A1err > 64) || (A1err < -63))
            return;
        A1sX      = (A1X < A1destX) ? 1 : -1;
        A1sY      = (A1Y < A1destY) ? 1 : -1;
        A1arrived = ((A1X == A1destX) && (A1Y == A1destY)) ? 1 : 0;

        A2destX = pArr2X;
        A2destY = pArr2Y;
        A2dX    = abs(A2destX - A2X);
        A2dY    = -abs(A2destY - A2Y);
        A2err   = A2dX + A2dY;
        if ((A2err > 64) || (A2err < -63))
            return;

        A2sX      = (A2X < A2destX) ? 1 : -1;
        A2sY      = (A2Y < A2destY) ? 1 : -1;
        A2arrived = ((A2X == A2destX) && (A2Y == A2destY)) ? 1 : 0;

        mDeltaY1 = (A1Y - A1destY);
        mDeltaX1 = (A1X - A1destX );
        mDeltaY2= (A2Y - A2destY);
        mDeltaX2 = (A2X - A2destX);

        isA1Right1 ();

        bresStepType1();

        A1X       = pArr1X;
        A1Y       = pArr1Y;
        A1destX   = pArr2X;
        A1destY   = pArr2Y;
        A1dX      = abs(A1destX - A1X);
        A1dY      = -abs(A1destY - A1Y);
        A1err     = A1dX + A1dY;
        A1sX      = (A1X < A1destX) ? 1 : -1;
        A1sY      = (A1Y < A1destY) ? 1 : -1;
        A1arrived = ((A1X == A1destX) && (A1Y == A1destY)) ? 1 : 0;

        bresStepType2();
    } else {
        // a1 = bres_agent(pDep[0],pDep[1],pArr2[0],pArr2[1])
        A1X     = pDepX;
        A1Y     = pDepY;
        A1destX = pArr2X;
        A1destY = pArr2Y;
        A1dX    = abs(A1destX - A1X);
        A1dY    = -abs(A1destY - A1Y);
        A1err   = A1dX + A1dY;

        if ((A1err > 64) || (A1err < -63))
            return;

        A1sX = (A1X < A1destX) ? 1 : -1;
        A1sY = (A1Y < A1destY) ? 1 : -1;

        A1arrived = ((A1X == A1destX) && (A1Y == A1destY)) ? 1 : 0;

        // a2 = bres_agent(pArr1[0],pArr1[1],pArr2[0],pArr2[1])
        A2X     = pArr1X;
        A2Y     = pArr1Y;
        A2destX = pArr2X;
        A2destY = pArr2Y;
        A2dX    = abs(A2destX - A2X);
        A2dY    = -abs(A2destY - A2Y);
        A2err   = A2dX + A2dY;

        if ((A2err > 64) || (A2err < -63))
            return;

        A2sX      = (A2X < A2destX) ? 1 : -1;
        A2sY      = (A2Y < A2destY) ? 1 : -1;
        A2arrived = ((A2X == A2destX) && (A2Y == A2destY)) ? 1 : 0;

        isA1Right3();
        bresStepType3() ;
    }
}
#endif // USE_C_FILL8




#ifdef USE_C_ISA1RIGHT1
void isA1Right1 (){
    
    A1Right = 0;
//  log2_tab[];
    if ((mDeltaX1 & 0x80) == 0){
        
        if ((mDeltaX2 & 0x80) == 0){
            // printf ("%d*%d  %d*%d ", mDeltaY1, mDeltaX2, mDeltaY2,mDeltaX1);get ();
            A1Right = ((log2_tab[mDeltaX2] + log2_tab[mDeltaY1])/2) > ((log2_tab[mDeltaX1] + log2_tab[mDeltaY2])/2);
            // A1Right = mDeltaY1*mDeltaX2 > mDeltaY2*mDeltaX1;
        } else {
            A1Right = 0 ; // (mDeltaX1 < 0) 
        }
    } else {
        if ((mDeltaX2 & 0x80) == 0){
            A1Right = 1 ; // (mDeltaX1 < 0)
        } else {
            // printf ("%d*%d  %d*%d ", mDeltaY1, -mDeltaX2, mDeltaY2,-mDeltaX1);get ();
            A1Right = ((log2_tab[abs(mDeltaX2)] + log2_tab[mDeltaY1])/2) < ((log2_tab[abs(mDeltaX1)] + log2_tab[mDeltaY2])/2);
        }
    }
    // if (((mDeltaX1 & 0x80) ^ (mDeltaX2 & 0x80)) == 0) {
    //     A1Right = mDeltaY1*mDeltaX2 > mDeltaY2*mDeltaX1; // (DeltaY1/DeltaX1) > (DeltaY2/DeltaX2) ;
    // }else {
    //     A1Right = (mDeltaX1 < 0) ;
    // }
    
    // A1Right = mDeltaY1*mDeltaX2 > mDeltaY2*mDeltaX1;


//  if (DeltaX1 == 0) {
//     A1Right = (DeltaX2 < 0);
//  } else {
//     if (DeltaX2 == 0){
//         A1Right = (DeltaX1 > 0);
//     } else {
//         if (((DeltaX1 & 0x80) ^ (DeltaX2 & 0x80)) == 0) {
//             A1Right = DeltaY1*DeltaX2 > DeltaY2*DeltaX1; // (DeltaY1/DeltaX1) > (DeltaY2/DeltaX2) ;
//         }else {
//             A1Right = (DeltaX1 > 0) ;
//         }
        
//     }
//  }
}
#endif // USE_C_ISA1RIGHT1



#ifdef USE_C_ISA1RIGHT3
void isA1Right3 (){
 A1Right = (A1X > A2X);
}
#endif // USE_C_ISA1RIGHT3


#ifdef USE_SATURATION
#ifdef USE_C_BRESTYPE1
void bresStepType1() {
    // printf ("hf (%d: %d, %d) = %d %d\n", A1X, A2X, A1Y, distface, ch2disp); get();
    reachScreen ();
    // A1Right = (A1X > A2X); 

    
    if (A1Right == 0) {
        initSatur_A1Left ();
        // printf ("bt1 A1L (%d: %d, %d) = A1XSatur=%d A2XSatur=%d\n", A1X, A2X, A1Y, A1XSatur, A2XSatur); get();
        hzfill();
        while ((A1arrived == 0) && (A1Y > 1)){
            A1stepY_A1Left();
            A2stepY_A1Left();
            // printf ("hf (%d: %d, %d) = %d %d\n", A1X, A2X, A1Y, distface, ch2disp); get();
            // A1Right = (A1X > A2X); 
            // printf ("bt1 A1L (%d: %d, %d) = A1XSatur=%d A2XSatur=%d\n", A1X, A2X, A1Y, A1XSatur, A2XSatur); get();
            hzfill();
        }
    } else {
        initSatur_A1Right ();
        // printf ("bt1 A1R (%d: %d, %d) = A1XSatur=%d A2XSatur=%d\n", A1X, A2X, A1Y, A1XSatur, A2XSatur); get();
        hzfill();
        while ((A1arrived == 0) && (A1Y > 1)){
            A1stepY_A1Right();
            A2stepY_A1Right();
            // printf ("hf (%d: %d, %d) = %d %d\n", A1X, A2X, A1Y, distface, ch2disp); get();
            // A1Right = (A1X > A2X); 
            // printf ("bt1 A1R (%d: %d, %d) = A1XSatur=%d A2XSatur=%d\n", A1X, A2X, A1Y, A1XSatur, A2XSatur); get();
            hzfill();
        }
    }
}
#endif // USE_C_BRESTYPE1


#ifdef USE_C_BRESTYPE2
void bresStepType2() {

    if (A1Right == 0) {
        initSatur_A1Left ();
        while ((A1arrived == 0) && (A2arrived == 0) && (A1Y > 1)) {
            A1stepY_A1Left();
            A2stepY_A1Left();
            // printf ("hf (%d: %d, %d) = %d %d\n", A1X, A2X, A1Y, distface, ch2disp); get();
            // A1Right = (A1X > A2X); 
            // printf ("bt2 A1L (%d: %d, %d) = A1XSatur=%d A2XSatur=%d\n", A1X, A2X, A1Y, A1XSatur, A2XSatur); get();
            hzfill();
        }
    } else {
        initSatur_A1Right ();
        while ((A1arrived == 0) && (A2arrived == 0) && (A1Y > 1)){
            A1stepY_A1Right();
            A2stepY_A1Right();
            // printf ("hf (%d: %d, %d) = %d %d\n", A1X, A2X, A1Y, distface, ch2disp); get();
            // A1Right = (A1X > A2X); 
            // printf ("bt2 A1R (%d: %d, %d) = A1XSatur=%d A2XSatur=%d\n", A1X, A2X, A1Y, A1XSatur, A2XSatur); get();
            hzfill();
        }
    }

}
#endif // USE_C_BRESTYPE2

#ifdef USE_C_BRESTYPE3
void bresStepType3() {

        // printf ("hf (%d: %d, %d) = %d %d\n", A1X, A2X, A1Y, distface, ch2disp); get();

    reachScreen ();

    // A1Right = (A1X > A2X); 
    if (A1Right == 0) {
        initSatur_A1Left ();
        hzfill();
        while ((A1arrived == 0) && (A2arrived == 0) && (A1Y > 1) ) {
            A1stepY_A1Left();
            A2stepY_A1Left();
            // printf ("hf (%d: %d, %d) = %d %d\n", A1X, A2X, A1Y, distface, ch2disp); get();
            // A1Right = (A1X > A2X); 
            hzfill();
        }
    } else {
        initSatur_A1Right ();
        hzfill();
        while ((A1arrived == 0) && (A2arrived == 0) && (A1Y > 1) ) {
            A1stepY_A1Right();
            A2stepY_A1Right();
            // printf ("hf (%d: %d, %d) = %d %d\n", A1X, A2X, A1Y, distface, ch2disp); get();
            // A1Right = (A1X > A2X); 
            hzfill();
        }
    }
}
#endif // USE_C_BRESTYPE3

#else // USE_SATURATION



#ifdef USE_C_BRESTYPE1

void bresStepType1() {
        // printf ("hf (%d: %d, %d) = %d %d\n", A1X, A2X, A1Y, distface, ch2disp); get();
        reachScreen()   ;
        // A1Right = (A1X > A2X); 
        hzfill();
        while ((A1arrived == 0) && (A1Y > 1)){
            A1stepY();
            A2stepY();
            // printf ("hf (%d: %d, %d) = %d %d\n", A1X, A2X, A1Y, distface, ch2disp); get();
            // A1Right = (A1X > A2X); 
            hzfill();

        }

}
#endif // USE_C_BRESTYPE1

#ifdef USE_C_BRESTYPE2
void bresStepType2() {
// #ifdef USE_PROFILER
//             PROFILE_ENTER(ROUTINE_BRESRUNTYPE2);
// #endif
       while ((A1arrived == 0) && (A2arrived == 0) && (A1Y > 1)) {
            A1stepY();
            A2stepY();
            // printf ("hf (%d: %d, %d) = %d %d\n", A1X, A2X, A1Y, distface, ch2disp); get();
            // A1Right = (A1X > A2X); 
            hzfill();
        }

}
#endif // USE_C_BRESTYPE2

#ifdef USE_C_BRESTYPE3

void bresStepType3() {
// #ifdef USE_PROFILER
//             PROFILE_ENTER(ROUTINE_BRESRUNTYPE3);
// #endif
        // printf ("hf (%d: %d, %d) = %d %d\n", A1X, A2X, A1Y, distface, ch2disp); get();
        reachScreen()   ;

        // A1Right = (A1X > A2X); 
        hzfill();

        while ((A1arrived == 0) && (A2arrived == 0) && (A1Y > 1) ) {
            A1stepY();
            A2stepY();
            // printf ("hf (%d: %d, %d) = %d %d\n", A1X, A2X, A1Y, distface, ch2disp); get();
            // A1Right = (A1X > A2X); 
            hzfill();
        }
// #ifdef USE_PROFILER
//             PROFILE_LEAVE(ROUTINE_BRESRUNTYPE3);
// #endif
}

#endif // USE_C_BRESTYPE3

#endif // USE_SATURATION

#ifdef USE_C_BRESFILL
void prepare_bresrun() {
    if (P1Y <= P2Y) {
        if (P2Y <= P3Y) {
            pDepX  = P3X;
            pDepY  = P3Y;
            pArr1X = P2X;
            pArr1Y = P2Y;
            pArr2X = P1X;
            pArr2Y = P1Y;
        } else {
            pDepX = P2X;
            pDepY = P2Y;
            if (P1Y <= P3Y) {
                pArr1X = P3X;
                pArr1Y = P3Y;
                pArr2X = P1X;
                pArr2Y = P1Y;
            } else {
                pArr1X = P1X;
                pArr1Y = P1Y;
                pArr2X = P3X;
                pArr2Y = P3Y;
            }
        }
    } else {
        if (P1Y <= P3Y) {
            pDepX  = P3X;
            pDepY  = P3Y;
            pArr1X = P1X;
            pArr1Y = P1Y;
            pArr2X = P2X;
            pArr2Y = P2Y;
        } else {
            pDepX = P1X;
            pDepY = P1Y;
            if (P2Y <= P3Y) {
                pArr1X = P3X;
                pArr1Y = P3Y;
                pArr2X = P2X;
                pArr2Y = P2Y;
            } else {
                pArr1X = P2X;
                pArr1Y = P2Y;
                pArr2X = P3X;
                pArr2Y = P3Y;
            }
        }
    }
}
#endif  // USE_C_BRESFILL

#ifdef USE_C_REACHSCREEN
void reachScreen(){
#ifdef USE_COLOR
        while ((A1Y >= SCREEN_HEIGHT-NB_LESS_LINES_4_COLOR) && (A1arrived == 0)){ 
#else
        while ((A1Y >= SCREEN_HEIGHT)  && (A1arrived == 0)){ 
#endif
            A1stepY();
            A2stepY();
        }
}
#endif // USE_C_REACHSCREEN

#ifdef USE_SATURATION

// #define USE_C_INITSATUR_A1RIGHT
#ifdef USE_C_INITSATUR_A1RIGHT
void initSatur_A1Right() {
    if (A1X > SCREEN_WIDTH - 1) {
        A1XSatur = 1;
    } else if (A1X == SCREEN_WIDTH - 1) {
        if (A1sX == 1) {
            A1XSatur = 1;
        } else {
            A1XSatur = 0;
        }
    } else {
        A1XSatur = 0;
    }

#ifndef USE_COLOR
    if (A2X < 0) {
#else
    if (A2X < COLUMN_OF_COLOR_ATTRIBUTE) {
#endif             
        A2XSatur = 1;
    } 
#ifndef USE_COLOR
    else if (A2X == 0) {
        
#else
    else if (A2X == COLUMN_OF_COLOR_ATTRIBUTE) {
#endif
        if (A2sX == 1) {
            A2XSatur = 0;
        } else {
            A2XSatur = 1;
        }

    } else {
        A2XSatur = 0;
    }
}
#endif // USE_C_INITSATUR_A1RIGHT

#ifdef USE_C_INITSATUR_A1LEFT
void initSatur_A1Left() {
    if (A2X > SCREEN_WIDTH - 1) {
        A2XSatur = 1;
    } else if (A2X == SCREEN_WIDTH - 1) {
        if (A2sX == 1){
            A2XSatur = 1;
        } else {
            A2XSatur = 0;
        }
    } else {
        A2XSatur = 0;
    }

#ifndef USE_COLOR
    if (A1X < 0) {
#else
    if (A1X < COLUMN_OF_COLOR_ATTRIBUTE) {
#endif             
        A1XSatur = 1;
#ifndef USE_COLOR
    } else if (A1X == 0) {
#else
    } else if (A1X == COLUMN_OF_COLOR_ATTRIBUTE) {
#endif             
        if (A1sX == 1){
            A1XSatur = 0;
        } else {
            A1XSatur = 1;
        }
    } else {
        A1XSatur = 0;
    }
}
#endif // USE_C_INITSATUR_A1LEFT

#ifdef USE_C_SWITCH_A1XSATUR
void switch_A1XSatur(){
    if (A1XSatur == 0) {
        A1XSatur = 1;
    } else {
        A1XSatur = 0;
    }
}
#endif //USE_C_SWITCH_A1XSATUR

#ifdef USE_C_SWITCH_A2XSATUR
void switch_A2XSatur(){
    if (A2XSatur == 0) {
        A2XSatur = 1;
    } else {
        A2XSatur = 0;
    }
}
#endif //USE_C_SWITCH_A2XSATUR
#endif // USE_SATURATION





#ifdef USE_SATURATION
#ifdef USE_C_AGENTSTEP

void A1stepY_A1Right() {
    signed char nxtY, e2;
    nxtY = A1Y + A1sY;
    //printf ("nxtY = %d\n", nxtY);
    e2 = (A1err < 0) ? (
                           ((A1err & 0x40) == 0) ? (
                                                       0x80)
                                                 : (
                                                       A1err << 1))
                     : (
                           ((A1err & 0x40) != 0) ? (
                                                       0x7F)
                                                 : (
                                                       A1err << 1));
    //printf ("e2 = %d\n", e2);
    while ((A1arrived == 0) && ((e2 > A1dX) || (A1Y != nxtY))) {
        if (e2 >= A1dY) {
            A1err += A1dY;
            //printf ("A1err = %d\n", A1err);
            A1X += A1sX;
            //printf ("A1X = %d\n", A1X);
            if (A1X == SCREEN_WIDTH - 1){
                switch_A1XSatur();
            }
        }
        if (e2 <= A1dX) {
            A1err += A1dX;
            //printf ("A1err = %d\n", A1err);
            A1Y += A1sY;
            //printf ("A1Y = %d\n", A1Y);
        }
        A1arrived = ((A1X == A1destX) && (A1Y == A1destY)) ? 1 : 0;
        e2        = (A1err < 0) ? (
                               ((A1err & 0x40) == 0) ? (
                                                           0x80)
                                                     : (
                                                           A1err << 1))
                         : (
                               ((A1err & 0x40) != 0) ? (
                                                           0x7F)
                                                     : (
                                                           A1err << 1));
        //printf ("e2 = %d\n", e2);
    }
}


void A2stepY_A1Right() {
    signed char nxtY, e2;
    nxtY = A2Y + A2sY;
    e2   = (A2err < 0) ? (
                           ((A2err & 0x40) == 0) ? (
                                                       0x80)
                                                 : (
                                                       A2err << 1))
                     : (
                           ((A2err & 0x40) != 0) ? (
                                                       0x7F)
                                                 : (
                                                       A2err << 1));
    while ((A2arrived == 0) && ((e2 > A2dX) || (A2Y != nxtY))) {
        if (e2 >= A2dY) {
            A2err += A2dY;
            A2X += A2sX;
#ifdef USE_COLOR
            if (A2X == COLUMN_OF_COLOR_ATTRIBUTE){
#else
            if (A2X == 0){
#endif
                switch_A2XSatur();
            }
        }
        if (e2 <= A2dX) {
            A2err += A2dX;
            A2Y += A2sY;
        }
        A2arrived = ((A2X == A2destX) && (A2Y == A2destY)) ? 1 : 0;
        e2        = (A2err < 0) ? (
                               ((A2err & 0x40) == 0) ? (
                                                           0x80)
                                                     : (
                                                           A2err << 1))
                         : (
                               ((A2err & 0x40) != 0) ? (
                                                           0x7F)
                                                     : (
                                                           A2err << 1));
    }
}

void A1stepY_A1Left() {
    signed char nxtY, e2;
    nxtY = A1Y + A1sY;
    //printf ("nxtY = %d\n", nxtY);
    e2 = (A1err < 0) ? (
                           ((A1err & 0x40) == 0) ? (
                                                       0x80)
                                                 : (
                                                       A1err << 1))
                     : (
                           ((A1err & 0x40) != 0) ? (
                                                       0x7F)
                                                 : (
                                                       A1err << 1));
    //printf ("e2 = %d\n", e2);
    while ((A1arrived == 0) && ((e2 > A1dX) || (A1Y != nxtY))) {
        if (e2 >= A1dY) {
            A1err += A1dY;
            //printf ("A1err = %d\n", A1err);
            A1X += A1sX;
#ifdef USE_COLOR
            if (A1X == COLUMN_OF_COLOR_ATTRIBUTE){
#else
            if (A1X == 0){
#endif
                switch_A1XSatur();
            }
            //printf ("A1X = %d\n", A1X);
        }
        if (e2 <= A1dX) {
            A1err += A1dX;
            //printf ("A1err = %d\n", A1err);
            A1Y += A1sY;
            //printf ("A1Y = %d\n", A1Y);
        }
        A1arrived = ((A1X == A1destX) && (A1Y == A1destY)) ? 1 : 0;
        e2        = (A1err < 0) ? (
                               ((A1err & 0x40) == 0) ? (
                                                           0x80)
                                                     : (
                                                           A1err << 1))
                         : (
                               ((A1err & 0x40) != 0) ? (
                                                           0x7F)
                                                     : (
                                                           A1err << 1));
        //printf ("e2 = %d\n", e2);
    }
}

void A2stepY_A1Left() {
    signed char nxtY, e2;
    nxtY = A2Y + A2sY;
    e2   = (A2err < 0) ? (
                           ((A2err & 0x40) == 0) ? (
                                                       0x80)
                                                 : (
                                                       A2err << 1))
                     : (
                           ((A2err & 0x40) != 0) ? (
                                                       0x7F)
                                                 : (
                                                       A2err << 1));
    while ((A2arrived == 0) && ((e2 > A2dX) || (A2Y != nxtY))) {
        if (e2 >= A2dY) {
            A2err += A2dY;
            A2X += A2sX;
            if (A2X == SCREEN_WIDTH - 1){
                switch_A2XSatur();
            }
        }
        if (e2 <= A2dX) {
            A2err += A2dX;
            A2Y += A2sY;
        }
        A2arrived = ((A2X == A2destX) && (A2Y == A2destY)) ? 1 : 0;
        e2        = (A2err < 0) ? (
                               ((A2err & 0x40) == 0) ? (
                                                           0x80)
                                                     : (
                                                           A2err << 1))
                         : (
                               ((A2err & 0x40) != 0) ? (
                                                           0x7F)
                                                     : (
                                                           A2err << 1));
    }
}


#endif // USE_C_AGENTSTEP
#endif // USE_SATURATION


#ifdef USE_C_HZFILL

void hzfill() {
//     signed char dx, fx;
//     signed char nbpoints;
    char*          ptrFbuf;
    unsigned char* ptrZbuf;

//     printf ("A1Right=%d A1XSatur=%d A2XSatur=%d \n", A1Right, A1XSatur, A2XSatur);waitkey();
    lineIndex = A1Y;
    if (A1Right != 0) {
#ifdef USE_SATURATION
        if (A2XSatur != 0){
#ifdef USE_COLOR
            departX = COLUMN_OF_COLOR_ATTRIBUTE;
#else
            departX = 0;
#endif // USE_COLOR

        } else {
            departX = A2X;
        }
#else // not USE_SATURATION	
#ifdef USE_COLOR
        departX = max(2, A2X);
#else
        departX = max(0, A2X);
#endif
#endif // USE_SATURATION

#ifdef USE_SATURATION
        if (A1XSatur != 0){
           finX = SCREEN_WIDTH - 1;     
        } else {
           finX = A1X;   
        }
#else // not USE_SATURATION	
        finX = min(A1X, SCREEN_WIDTH - 1);
#endif // USE_SATURATION

        
    } else {
#ifdef USE_SATURATION
        if (A1XSatur != 0) {
#ifdef USE_COLOR		
	    departX = COLUMN_OF_COLOR_ATTRIBUTE;
#else
	    departX = 0;
#endif // USE_COLOR
        } else {
            departX = A1X;
        }
#else // not USE_SATURATION
#ifdef USE_COLOR
        departX = max(COLUMN_OF_COLOR_ATTRIBUTE, A1X);
#else
        departX = max(0, A1X);
#endif
#endif // USE_SATURATION

#ifdef  USE_SATURATION
        if (A2XSatur !=0){
                finX = SCREEN_WIDTH - 1;
        } else {
                finX = A2X;
        }
#else // USE_SATURATION
        finX = min(A2X, SCREEN_WIDTH - 1);
#endif // USE_SATURATION
    }
//     printf ("finX=%d, departX=%d \n", finX , departX);waitkey();
    hLineLength = finX - departX;
    if (hLineLength < 0) return;
    
    ptrZbuf = zbuffer + lineIndex * SCREEN_WIDTH + departX;
    ptrFbuf = fbuffer + lineIndex * SCREEN_WIDTH + departX;
    
    
    while (hLineLength > 0) {
        // printf ("hLineLength=%d \n", hLineLength);waitkey();
        if (distface < ptrZbuf[hLineLength]) {
                ptrFbuf[hLineLength] = ch2disp;
                ptrZbuf[hLineLength] = distface;
        }
        hLineLength --;
    }

}

#endif  // USE_C_HZFILL


#ifdef USE_C_BRESFILL

void A1stepY() {
    signed char nxtY, e2;
    nxtY = A1Y + A1sY;
    //printf ("nxtY = %d\n", nxtY);
    e2 = (A1err < 0) ? (
                           ((A1err & 0x40) == 0) ? (
                                                       0x80)
                                                 : (
                                                       A1err << 1))
                     : (
                           ((A1err & 0x40) != 0) ? (
                                                       0x7F)
                                                 : (
                                                       A1err << 1));
    //printf ("e2 = %d\n", e2);
    while ((A1arrived == 0) && ((e2 > A1dX) || (A1Y != nxtY))) {
        if (e2 >= A1dY) {
            A1err += A1dY;
            //printf ("A1err = %d\n", A1err);
            A1X += A1sX;
            //printf ("A1X = %d\n", A1X);
        }
        if (e2 <= A1dX) {
            A1err += A1dX;
            //printf ("A1err = %d\n", A1err);
            A1Y += A1sY;
            //printf ("A1Y = %d\n", A1Y);
        }
        A1arrived = ((A1X == A1destX) && (A1Y == A1destY)) ? 1 : 0;
        e2        = (A1err < 0) ? (
                               ((A1err & 0x40) == 0) ? (
                                                           0x80)
                                                     : (
                                                           A1err << 1))
                         : (
                               ((A1err & 0x40) != 0) ? (
                                                           0x7F)
                                                     : (
                                                           A1err << 1));
        //printf ("e2 = %d\n", e2);
    }
}

void A2stepY() {
    signed char nxtY, e2;
    nxtY = A2Y + A2sY;
    e2   = (A2err < 0) ? (
                           ((A2err & 0x40) == 0) ? (
                                                       0x80)
                                                 : (
                                                       A2err << 1))
                     : (
                           ((A2err & 0x40) != 0) ? (
                                                       0x7F)
                                                 : (
                                                       A2err << 1));
    while ((A2arrived == 0) && ((e2 > A2dX) || (A2Y != nxtY))) {
        if (e2 >= A2dY) {
            A2err += A2dY;
            A2X += A2sX;
        }
        if (e2 <= A2dX) {
            A2err += A2dX;
            A2Y += A2sY;
        }
        A2arrived = ((A2X == A2destX) && (A2Y == A2destY)) ? 1 : 0;
        e2        = (A2err < 0) ? (
                               ((A2err & 0x40) == 0) ? (
                                                           0x80)
                                                     : (
                                                           A2err << 1))
                         : (
                               ((A2err & 0x40) != 0) ? (
                                                           0x7F)
                                                     : (
                                                           A2err << 1));
    }
}
#endif  // USE_C_BRESFILL


#ifdef USE_C_PLOT

void plot(signed char X,
           signed char Y,
           char          char2disp) {
    int            offset;
    char*          ptrScreen = (char*)ADR_BASE_LORES_SCREEN;


#ifdef USE_COLOR
    if ((Y <= 0) || (Y >= SCREEN_HEIGHT-NB_LESS_LINES_4_COLOR) || (X <= 2) || (X >= SCREEN_WIDTH))
        return;
#else
    if ((Y <= 0) || (Y >= SCREEN_HEIGHT) || (X <= 0) || (X >= SCREEN_WIDTH))
        return;
#endif

#ifdef USE_MULTI40
    offset = multi40[Y] + X;  // 
#else
    offset = Y*SCREEN_WIDTH+X; 
#endif

    *(ptrScreen + offset) = char2disp;
}
#endif // USE_C_PLOT


#ifdef USE_C_BUFFER2SCREEN
void glBuffer2Screen() {
#ifdef __GNUC__ 
#ifdef USE_NCURSES
    int ii, jj;
    for (ii=2; ii<40; ii++){
        for (jj=0; jj<26; jj++){
            mvaddch(jj,ii, *(fbuffer+40*jj + ii));
        }
    }

#else // Not USE_NCURSES
    int ii;
    for (ii=0; ii<SCREEN_HEIGHT; ii++){
        *(fbuffer+40*ii + 39) = '\0';
        printf ("%s\n", fbuffer+40*ii);
    }
    get();
#endif 
#else // Not _GNUC__ 
    memcpy((void*)ADR_BASE_LORES_SCREEN, fbuffer, SCREEN_HEIGHT* SCREEN_WIDTH);
#endif
}
#endif 



#ifdef USE_C_GLDRAWPARTICLES
void glDrawParticles(){
    unsigned char ii = 0;

    unsigned char idxPt, offPt, dchar;
    unsigned int  dist;


    for (ii = 0; ii < glNbParticles; ii++) {
        idxPt    = glParticlesPt[ii];  // ii*SIZEOF_SEGMENT +0
        ch2disp = glParticlesChar[ii];    // ii*SIZEOF_SEGMENT +2
        // printf ("particles : %d %d\n ", idxPt, ch2disp);
        dchar = points2dL[idxPt]-2 ; //FIXME : -2 to helps particle to be displayed
        P1X = (SCREEN_WIDTH -points2aH[idxPt]) >> 1;
        P1Y = (SCREEN_HEIGHT - points2aV[idxPt]) >> 1;
#ifdef USE_ZBUFFER
        glZPlot(P1X, P1Y, dchar, ch2disp);
#else
        // TODO : plot a point with no z-buffer
        plot(A1X, A1Y, ch2disp);
#endif

    }

}
#endif // USE_C_GLDRAWPARTICLES


#ifdef USE_C_GLPROJECTPOINT
 // Point 3D Coordinates
int PointX;
int PointY;
int PointZ;

 // Point 2D Projected Coordinates
char ResX;			// -128 -> -127
char ResY;

 // Intermediary Computation
int DeltaX;
int DeltaY;
int DeltaZ;
char Norm;
char AngleH;
char AngleV;
char AnglePH; //  .dsb 1 ; horizontal angle of point from player pov
char AnglePV; // .dsb 1 ; vertical angle of point from player pov

void glProjectPoint(signed char x, signed char y, signed char z, unsigned char options, signed char *ah, signed char *av, unsigned int *dist){

PointX = x;
PointY = y;
PointZ = z;

// project_i8o8();
	DeltaX = glCamPosX - PointX;
	
    DeltaY = glCamPosY - PointY;
    AngleH = batan2 (DeltaY, DeltaX);
    Norm = norm (DeltaX, DeltaY);
    DeltaZ = glCamPosZ - PointZ;
    AngleV = batan2 (DeltaZ, Norm);
    AnglePH = AngleH - glCamRotZ;
    AnglePV = AngleV - glCamRotX;

    ResX = AnglePH;
    ResY = AnglePV;

    *ah=ResX;
    *av=ResY;
    *dist=Norm;

}
#endif