

#define HOUSE_SIZE_X 12
#define HOUSE_SIZE_Y 8
#define HOUSE_SIZE_Z 4

// static signed char geomHouse_old [8]= {
//     10, 11, 14, 0, 
//     1*SIZE_X, 1*HOUSE_SIZE_Y, 0*HOUSE_SIZE_Z, 0
// };


                                                        //               9
static signed char geomHouse []= {                      //              /  \          
                                                        //             /    \    
/* Nb Coords = */ 10,                                   //            /      \   
/* Nb Faces = */ 11,                                    //           /        \   
/* Nb Segments = */ 14,                                 //          5         4  
/* Nb Particles = */ 0,                                 //         /.        /|  
                                                        //        8 .       / |  
// Coord List : X, Y, Z, unused                         //       / \.      /  |  
 1*HOUSE_SIZE_X, 1*HOUSE_SIZE_Y, 0*HOUSE_SIZE_Z, 0,                       //      /   \     /   |                            
-1*HOUSE_SIZE_X, 1*HOUSE_SIZE_Y, 0*HOUSE_SIZE_Z, 1,                       //     /    1\.. /. . 0                           
-1*HOUSE_SIZE_X,-1*HOUSE_SIZE_Y, 0*HOUSE_SIZE_Z, 2,                       //    /     / \ /    /                            
 1*HOUSE_SIZE_X,-1*HOUSE_SIZE_Y, 0*HOUSE_SIZE_Z, 3,                       //   6     /   7    /                             
 1*HOUSE_SIZE_X, 1*HOUSE_SIZE_Y, 2*HOUSE_SIZE_Z, 4,                       //   |    /    |   /                               
-1*HOUSE_SIZE_X, 1*HOUSE_SIZE_Y, 2*HOUSE_SIZE_Z, 5,                       //   |   /     |  /                               
-1*HOUSE_SIZE_X,-1*HOUSE_SIZE_Y, 2*HOUSE_SIZE_Z, 6,                       //   |  /      | /                                
 1*HOUSE_SIZE_X,-1*HOUSE_SIZE_Y, 2*HOUSE_SIZE_Z, 7,                       //   | /       |/                                 
 1*HOUSE_SIZE_X, 0*HOUSE_SIZE_Y, 3*HOUSE_SIZE_Z, 8,                       //   |/________|                                  
-1*HOUSE_SIZE_X, 0*HOUSE_SIZE_Y, 3*HOUSE_SIZE_Z, 9,        
// Face List : idxPoint1, idxPoint2, idxPoint3, character 
 0, 1, 5, TEXTURE_RED,      // side
 0, 4, 5, TEXTURE_RED,
 3, 2, 6, TEXTURE_RED,
 6, 3, 7, TEXTURE_RED,
 1, 2, 6, TEXTURE_MAGENTA, // back
 1, 6, 5, TEXTURE_MAGENTA,
 5, 6, 9, TEXTURE_MAGENTA,
 4, 5, 9, TEXTURE_YELLOW,  // roof
 4, 9, 8, TEXTURE_YELLOW,
 7, 6, 9, TEXTURE_YELLOW,
 7, 9, 8, TEXTURE_YELLOW,
// Segment List : idxPoint1, idxPoint2, character , unused
0, 1, '-', 0,
1, 2, '-', 0,
2, 3, '-', 0,
4, 5, '-', 0,
6, 7, '-', 0,
0, 4, '|', 0,
1, 5, '|', 0,
2, 6, '|', 0,
3, 7, '|', 0,
4, 8, '/', 0,
7, 8, '/', 0,
5, 9, '/', 0,
6, 9, '/', 0,
9, 8, '-', 0,
}; 


#define TRUNC_HEIGHT 1
#define PINE_WIDTH 1
#define PINE_HEIGHT 3
#define PINE_SIZE_X 9
#define PINE_SIZE_Y 9
#define PINE_SIZE_Z 9
                                             //          6
signed char geomPine []= {                   //          /\       
                                             //         /| \      
/* Nb Coords = */ 7,                         //        //   \\    
/* Nb Faces = */ 2,                          //       //    \ \3   
/* Nb Segments = */ 1,                       //      / /     \/   
/* Nb Particles = */ 0,                     //     / /       \   
                                             //    /  /        \  
// Coord List : X, Y, Z, unused              //   /  /         \  
PINE_SIZE_X*0,          PINE_SIZE_Y*0,          PINE_SIZE_Z*0,              0,   //  4---/   1------2 
PINE_SIZE_X*0,          PINE_SIZE_Y*0,          PINE_SIZE_Z*TRUNC_HEIGHT,   1,   //     /  //|        
PINE_SIZE_X*PINE_WIDTH, PINE_SIZE_Y*0,          PINE_SIZE_Z*TRUNC_HEIGHT,   2,   //     / /  |        
PINE_SIZE_X*0,          PINE_SIZE_Y*PINE_WIDTH, PINE_SIZE_Z*TRUNC_HEIGHT,   3,   //    ///   |        
PINE_SIZE_X*-PINE_WIDTH,PINE_SIZE_Y* 0,         PINE_SIZE_Z*TRUNC_HEIGHT,   4,   //    /     |        
PINE_SIZE_X*0,          PINE_SIZE_Y*-PINE_WIDTH,PINE_SIZE_Z*TRUNC_HEIGHT,   5,   //   5      |        
PINE_SIZE_X*0,          PINE_SIZE_Y*0,          PINE_SIZE_Z*PINE_HEIGHT,    6,   //          |        
                                             //          0        
// Face List : idxPoint1, idxPoint2, idxPoint3, character 
3, 5, 6, TEXTURE_GREEN,
2, 4, 6, TEXTURE_GREEN,
// Segment List : idxPoint1, idxPoint2, character , unused
0, 1, '|', 0,
// Particle List : idxPoint1, character 
};

#define TOWER_HEIGHT 3   
#define TOWER_SIXE_X 6
#define TOWER_SIZE_Y 6
#define TOWER_SIZE_Z 12    
signed char geomTower []= {                                           //           7---------------6
/* Nb Coords = */ 8,                                                  //           |             //|
/* Nb Faces = */ 6,                                                   //           |           //  |
/* Nb Segments = */ 4,                                                //           |         //    |
/* Nb Particles = */ 0,                                               //           |       //      |
// Coord List : X, Y, Z, Id                                           //  4--------------5/        |
-1*TOWER_SIXE_X, -1*TOWER_SIZE_Y,             0*TOWER_SIZE_Z, 0,      //  |        .     |         |
-1*TOWER_SIXE_X,  1*TOWER_SIZE_Y,             0*TOWER_SIZE_Z, 1,      //  |        .     |         |
 1*TOWER_SIXE_X,  1*TOWER_SIZE_Y,             0*TOWER_SIZE_Z, 2,      //  |        .     |         |
 1*TOWER_SIXE_X, -1*TOWER_SIZE_Y,             0*TOWER_SIZE_Z, 3,      //  |        .     |         |
-1*TOWER_SIXE_X, -1*TOWER_SIZE_Y,  TOWER_HEIGHT*TOWER_SIZE_Z, 4,      //  |        .     |         |
-1*TOWER_SIXE_X,  1*TOWER_SIZE_Y,  TOWER_HEIGHT*TOWER_SIZE_Z, 5,      //  |        .     |         |
 1*TOWER_SIXE_X,  1*TOWER_SIZE_Y,  TOWER_HEIGHT*TOWER_SIZE_Z, 6,      //  |              |         |
 1*TOWER_SIXE_X, -1*TOWER_SIZE_Y,  TOWER_HEIGHT*TOWER_SIZE_Z, 7,      //  |        3.....|........ 2
// Face List                                                          //  |              |       // 
0, 1, 4, TEXTURE_CYAN,                                                //  |              |     //   
1, 4, 5, TEXTURE_CYAN,                                                //  |              |    /     
1, 2, 5, TEXTURE_BLUE,                                                //  |              |  //      
2, 5, 6, TEXTURE_BLUE,                                                //  |               //        
3, 2, 7, TEXTURE_CYAN,                                                //  0------------- 1          
2, 7, 6, TEXTURE_CYAN,
// Segment List : idxPoint1, idxPoint2, character, unused 
0, 4, '|',       0,
3, 7, '|',       0,
2, 6, '|',       0,
1, 5, '|',       0,
};
  


#ifdef  USE_ASM_SHAPELOADER_DATA
extern signed char scnNewShapeX, scnNewShapeY, scnNewShapeZ;
extern signed char scnNewPointX, scnNewPointY, scnNewPointZ;
extern unsigned char scnNewPointIdxPt1, scnNewPointIdxPt2, scnNewPointIdxPt3;
extern char scnNewPointChar;
extern signed char scnNewShapeOrientation;
extern unsigned char npt, nfa, nseg, npart;
extern signed char          *scnData;
extern unsigned char scnTmp;
extern unsigned char scnReadPointer;
#endif  // USE_ASM_SHAPELOADER_DATA

#ifdef  USE_C_SHAPELOADER_DATA
static signed char scnNewShapeX, scnNewShapeY, scnNewShapeZ;
static signed char scnNewPointX, scnNewPointY, scnNewPointZ;
static unsigned char scnNewPointIdxPt1, scnNewPointIdxPt2, scnNewPointIdxPt3;
static char scnNewPointChar;
static unsigned char npt, nfa, nseg, npart;
static signed char scnNewShapeOrientation;
static signed char          *scnData;
static unsigned char scnTmp;
static unsigned char scnReadPointer;
#endif  // USE_C_SHAPELOADER_DATA

#ifdef  USE_C_SHAPELOADER

void scnAddVertice (){
    glVerticesX[glNbVertices] = scnNewPointX;
    glVerticesY[glNbVertices] = scnNewPointY;
    glVerticesZ[glNbVertices] = scnNewPointZ;
    glNbVertices++;

}
void scnAddFace () {
    glFacesPt1[glNbFaces]  = scnNewPointIdxPt1;  // Index Point 1
    glFacesPt2[glNbFaces]  = scnNewPointIdxPt2;  // Index Point 2
    glFacesPt3[glNbFaces]  = scnNewPointIdxPt3;  // Index Point 3
    glFacesChar[glNbFaces] = scnNewPointChar;  // Character
    glNbFaces++;
}
void scnAddSegment (){
    glSegmentsPt1[glNbSegments] = scnNewPointIdxPt1;  // Index Point 1
    glSegmentsPt2[glNbSegments] = scnNewPointIdxPt2;  // Index Point 2
    glSegmentsChar[glNbSegments] = scnNewPointChar; // Character
    glNbSegments++;

}
void scnAddParticule (){
    glParticlesPt[glNbParticles] = scnNewPointIdxPt1;  // Index Point
    glParticlesChar[glNbParticles] = scnNewPointChar; // Character
    glNbParticles++;        
}
#endif  // USE_C_SHAPELOADER


void addGeom(
    signed char   X,
    signed char   Y,
    signed char   Z,
    unsigned char sizeX,
    unsigned char sizeY,
    unsigned char sizeZ,
    unsigned char orientation,
    signed char          geom[]) {


    int ii;
    scnNewShapeOrientation = orientation;
    scnData          = geom;
    scnNewShapeX = X;
    scnNewShapeY = Y;
    scnNewShapeZ = Z;

#ifdef  USE_C_SHAPELOADER

    scnReadPointer = 0;
    npt = scnData[scnReadPointer++];
    nfa = scnData[scnReadPointer++];
    nseg = scnData[scnReadPointer++];
    npart = scnData[scnReadPointer++];
    scnTmp = glNbVertices + npt;

    do {


        if (scnNewShapeOrientation == 0) {
            scnNewPointX = scnNewShapeX + sizeX * scnData[scnReadPointer++];
            scnNewPointY = scnNewShapeY + sizeY * scnData[scnReadPointer++];
        } else {
            scnNewPointY = scnNewShapeX + sizeY * scnData[scnReadPointer++];
            scnNewPointX = scnNewShapeY + sizeX * scnData[scnReadPointer++];
        }
        scnNewPointZ = scnNewShapeZ + sizeZ * scnData[scnReadPointer++];
        scnAddVertice ();
        scnReadPointer++; // skip unused byte

    } while (glNbVertices != scnTmp); 

    scnTmp = glNbVertices - npt;

    for (ii = 0; ii < nfa; ii++){
        scnNewPointIdxPt1 = scnTmp+scnData[scnReadPointer++];  // Index Point 1
        scnNewPointIdxPt2 = scnTmp+scnData[scnReadPointer++];  // Index Point 2
        scnNewPointIdxPt3 = scnTmp+scnData[scnReadPointer++];  // Index Point 3
        scnNewPointChar   = scnData[scnReadPointer++];  // Character
        scnAddFace ();
    }

    for (ii = 0; ii < nseg; ii++){
        scnNewPointIdxPt1 = scnTmp+scnData[scnReadPointer++];  // Index Point 1
        scnNewPointIdxPt2 = scnTmp+scnData[scnReadPointer++];  // Index Point 2
        scnNewPointChar   = scnData[scnReadPointer++]; // Character
        scnAddSegment ();
        scnReadPointer++; // skip unused byte
    }

    for (ii = 0; ii < npart; ii++){
        scnNewPointIdxPt1 = scnTmp+scnData[scnReadPointer++];  // Index Point
        scnNewPointChar   = scnData[scnReadPointer++]; // Character
        scnAddParticule ();        
    }
#endif // USE_C_SHAPELOADER
#ifdef USE_ASM_SHAPELOADER
    scnLoadShape();
#endif

}  

/*
void addGeom_old(
    signed char   X,
    signed char   Y,
    signed char   Z,
    unsigned char sizeX,
    unsigned char sizeY,
    unsigned char sizeZ,
    unsigned char orientation,
    signed char          geom[]) {

    int kk=0;
    int ii;
    int npt,nfa, nseg, npart;
    npt = geom[kk++];
    nfa = geom[kk++];
    nseg = geom[kk++];
    npart = geom[kk++];
    for (ii = 0; ii < npt; ii++){
        if (orientation == 0) {
            glVerticesX[glNbVertices] = X + sizeX * geom[kk++];
            glVerticesY[glNbVertices] = Y + sizeY * geom[kk++];
        } else {
            glVerticesY[glNbVertices] = X + sizeY * geom[kk++];
            glVerticesX[glNbVertices] = Y + sizeX * geom[kk++];
        }
        glVerticesZ[glNbVertices] = Z + sizeZ * geom[kk++];
        glNbVertices ++;
        kk++; // skip unused byte
    }
    for (ii = 0; ii < nfa; ii++){
        glFacesPt1[glNbFaces] = glNbVertices - (npt-geom[kk++]);  // Index Point 1
        glFacesPt2[glNbFaces] = glNbVertices - (npt-geom[kk++]);  // Index Point 2
        glFacesPt3[glNbFaces] = glNbVertices - (npt-geom[kk++]);  // Index Point 3
        glFacesChar[glNbFaces] = geom[kk++];  // Character
        glNbFaces++;
    }
    for (ii = 0; ii < nseg; ii++){
        glSegmentsPt1[glNbSegments] = glNbVertices - (npt-geom[kk++]);  // Index Point 1
        glSegmentsPt2[glNbSegments] = glNbVertices - (npt-geom[kk++]);  // Index Point 2
        glSegmentsChar[glNbSegments] = geom[kk++]; // Character
        glNbSegments++;
        kk++; // skip unused byte
    }
    for (ii = 0; ii < npart; ii++){
        glParticlesPt[glNbParticles] = glNbVertices - (npt-geom[kk++]);  // Index Point
        glParticlesChar[glNbParticles] = geom[kk++]; // Character
        glNbParticles++;        
    }
}    
*/


void glSceneInit(void){
    /*
     *  Game Scene Building
     */
    glNbVertices     = 0;
    glNbSegments   = 0;
    glNbFaces      = 0;
    glNbParticles = 0;

    addGeom(24, -24, 0, 1, 1, 1, 0, geomTower);
    // addGeom(-24, 24, 3, 1, 1, 1, 0, geomHouse);
    // addGeom(12, -12, 3, 1, 1, 1, 0, geomHouse);
    addGeom(24, 12, 0, 1, 1, 1, 0, geomPine);
    
    initColors();
    /*
     *  Camera (player view) position and orientation 
     */
    glCamPosX = START_POS_X ;  
    glCamPosY = START_POS_Y ; 
    glCamPosZ = START_POS_Z ;
    glCamRotZ = START_ROT_Z ;
    glCamRotX = START_ROT_X ;
}



#define SHIP_SIZE_X 4
#define SHIP_SIZE_Y 4
#define SHIP_SIZE_Z 4

static signed char geomShip []= { 
/* Nb Coords = */ 4,  
/* Nb Faces = */ 3,   
/* Nb Segments = */ 6,
/* Nb Particles = */ 0,
// Coord List : X, Y, Z, unused   
0  *SHIP_SIZE_X , 0 *SHIP_SIZE_Y    , 2 *SHIP_SIZE_Z    , 0, 
0  *SHIP_SIZE_X , 2 *SHIP_SIZE_Y    , 0 *SHIP_SIZE_Z    , 1, 
2  *SHIP_SIZE_X , 0 *SHIP_SIZE_Y    , 0 *SHIP_SIZE_Z    , 2, 
-2 *SHIP_SIZE_X ,-2 *SHIP_SIZE_Y    , 0 *SHIP_SIZE_Z    , 3, 

0  *SHIP_SIZE_X , 1 *SHIP_SIZE_Y    , 2 *SHIP_SIZE_Z    , 0, 
2  *SHIP_SIZE_X , 1 *SHIP_SIZE_Y    , 0 *SHIP_SIZE_Z    , 1, 
2  *SHIP_SIZE_X ,-1 *SHIP_SIZE_Y    , 0 *SHIP_SIZE_Z    , 2, 
-2 *SHIP_SIZE_X , 0 *SHIP_SIZE_Y    , 0 *SHIP_SIZE_Z    , 3, 

// Face List : idxPoint1, idxPoint2, idxPoint3, character 
 0, 1, 2, TEXTURE_RED,      // side
 0, 2, 3, TEXTURE_YELLOW,      // side
 0, 1, 3, TEXTURE_YELLOW,      // side

// Segment List : idxPoint1, idxPoint2, character , unused
0, 1, '/', 0,
0, 2, '/', 0,
0, 3, '/', 0,
1, 2, '-', 0,
2, 3, '-', 0,
3, 1, '-', 0,

};

// static signed char geomShip_01 []= { 
// /* Nb Coords = */ 4,  
// /* Nb Faces = */ 3,   
// /* Nb Segments = */ 6,
// /* Nb Particles = */ 0,
// // Coord List : X, Y, Z, unused   
// 0  *SHIP_SIZE_X , 1 *SHIP_SIZE_Y    , 2 *SHIP_SIZE_Z    , 0, 
// 2  *SHIP_SIZE_X , 1 *SHIP_SIZE_Y    , 0 *SHIP_SIZE_Z    , 1, 
// 2  *SHIP_SIZE_X ,-1 *SHIP_SIZE_Y    , 0 *SHIP_SIZE_Z    , 2, 
// -2 *SHIP_SIZE_X , 0 *SHIP_SIZE_Y    , 0 *SHIP_SIZE_Z    , 3, 
// // Face List : idxPoint1, idxPoint2, idxPoint3, character 
//  0, 1, 2, TEXTURE_RED,      // side
//  0, 2, 3, TEXTURE_YELLOW,      // side
//  0, 1, 3, TEXTURE_YELLOW,      // side

// // Segment List : idxPoint1, idxPoint2, character , unused
// 0, 1, '/', 0,
// 0, 2, '/', 0,
// 0, 3, '/', 0,
// 1, 2, '-', 0,
// 2, 3, '-', 0,
// 3, 1, '-', 0,

// };



// void addOrientableGeom(
//     signed char   X,
//     signed char   Y,
//     signed char   Z,
//     unsigned char orientation,
//     signed char          geom[]) {
// int ii;
//     scnNewShapeOrientation = orientation;
//     scnData          = geom;
//     scnNewShapeX = X;
//     scnNewShapeY = Y;
//     scnNewShapeZ = Z;
//     scnReadPointer = 0;
//     npt = scnData[scnReadPointer++];
//     nfa = scnData[scnReadPointer++];
//     nseg = scnData[scnReadPointer++];
//     npart = scnData[scnReadPointer++];

//     if (scnNewShapeOrientation % 2 != 0) {
//         scnReadPointer += npt*SIZEOF_3DPOINT;
//     }
//     scnTmp = glNbVertices + npt;

//     do {


//         if (scnNewShapeOrientation == 0) {
//             scnNewPointX = scnNewShapeX + scnData[scnReadPointer++];
//             scnNewPointY = scnNewShapeY + scnData[scnReadPointer++];
//         } else if (scnNewShapeOrientation == 1) {
//             scnNewPointX = scnNewShapeX + scnData[scnReadPointer++];
//             scnNewPointY = scnNewShapeY + scnData[scnReadPointer++];
//         } else if (scnNewShapeOrientation == 2) {
//             scnNewPointY = scnNewShapeY + scnData[scnReadPointer++];
//             scnNewPointX = scnNewShapeX - scnData[scnReadPointer++];
//         } else if (scnNewShapeOrientation == 3) {
//             scnNewPointY = scnNewShapeY + scnData[scnReadPointer++];
//             scnNewPointX = scnNewShapeX - scnData[scnReadPointer++];
//         } else if (scnNewShapeOrientation == 4) {
//             scnNewPointX = scnNewShapeX - scnData[scnReadPointer++];
//             scnNewPointY = scnNewShapeY - scnData[scnReadPointer++];
//         } else if (scnNewShapeOrientation == 5) {
//             scnNewPointX = scnNewShapeX - scnData[scnReadPointer++];
//             scnNewPointY = scnNewShapeY - scnData[scnReadPointer++];
//         } else if (scnNewShapeOrientation == 6) {
//             scnNewPointY = scnNewShapeY - scnData[scnReadPointer++];
//             scnNewPointX = scnNewShapeX + scnData[scnReadPointer++];
//         } else if (scnNewShapeOrientation == 7) {
//             scnNewPointY = scnNewShapeY - scnData[scnReadPointer++];
//             scnNewPointX = scnNewShapeX + scnData[scnReadPointer++];
//         }
//         scnNewPointZ = scnNewShapeZ + scnData[scnReadPointer++];
//         scnAddVertice ();
//         scnReadPointer++; // skip unused byte

//     } while (glNbVertices != scnTmp); 

//     if (scnNewShapeOrientation % 2 == 0) {
//         scnReadPointer += npt*SIZEOF_3DPOINT;
//     }

//     scnTmp = glNbVertices - npt;

//     for (ii = 0; ii < nfa; ii++){
//         scnNewPointIdxPt1 = scnTmp+scnData[scnReadPointer++];  // Index Point 1
//         scnNewPointIdxPt2 = scnTmp+scnData[scnReadPointer++];  // Index Point 2
//         scnNewPointIdxPt3 = scnTmp+scnData[scnReadPointer++];  // Index Point 3
//         scnNewPointChar   = scnData[scnReadPointer++];  // Character
//         scnAddFace ();
//     }

//     for (ii = 0; ii < nseg; ii++){
//         scnNewPointIdxPt1 = scnTmp+scnData[scnReadPointer++];  // Index Point 1
//         scnNewPointIdxPt2 = scnTmp+scnData[scnReadPointer++];  // Index Point 2
//         scnNewPointChar   = scnData[scnReadPointer++]; // Character
//         scnAddSegment ();
//         scnReadPointer++; // skip unused byte
//     }

//     for (ii = 0; ii < npart; ii++){
//         scnNewPointIdxPt1 = scnTmp+scnData[scnReadPointer++];  // Index Point
//         scnNewPointChar   = scnData[scnReadPointer++]; // Character
//         scnAddParticule ();        
//     }
// }