
#include "ray_param.h"

#define USE_ASM_TOTO
#define USE_ASM_PREDRAW
#define USE_ASM_RAYCASTING
#ifdef USE_ASM_RAYCASTING_DATA
.zero 
; static unsigned char* tab_denom;
_tab_denom:             .dsb 2

.text

; static signed char rayCamPosY, rayCamPosX, rayCamRotZ;
_rayCamPosY:		.dsb 1
_rayCamPosX:		.dsb 1
_rayCamRotZ:		.dsb 1
; static unsigned char rayNbPoints;
_rayNbPoints:		.dsb 1
; static unsigned char rayNbWalls;
_rayNbWalls:		.dsb 1
; static signed char    lPointsX[NB_MAX_POINT];
_lPointsX:		    .dsb NB_MAX_POINT
; static signed char    lPointsY[NB_MAX_POINT];
_lPointsY:		    .dsb NB_MAX_POINT
; static unsigned char  lWallsPt1[NB_MAX_WALL];
_lWallsPt1:		    .dsb NB_MAX_WALL
; static unsigned char  lWallsPt2[NB_MAX_WALL];
_lWallsPt2:		    .dsb NB_MAX_WALL
; static unsigned char  rayzbuffer[NB_SLICES];
_rayzbuffer:		.dsb NB_SLICES
; static unsigned char  TableVerticalPos[NB_SLICES];
_TableVerticalPos:  .dsb NB_SLICES
; static unsigned char  raywall[NB_SLICES];
_raywall:           .dsb NB_SLICES



; static signed char    lAngle[NB_MAX_POINT];
_lAngle:		    .dsb NB_MAX_POINT
; static unsigned char  isFront[NB_MAX_POINT];
_isFront:		    .dsb NB_MAX_POINT
; static unsigned char  isVisible[NB_MAX_POINT];
_isVisible:		    .dsb NB_MAX_POINT
; static signed char    lWallsCosBeta[NB_MAX_WALL];
_lWallsCosBeta:		    .dsb NB_MAX_WALL
; static signed char    RayAlpha;
_RayAlpha:		        .dsb 1
; static signed char    RayLeftAlpha;
_RayLeftAlpha:		    .dsb 1
; static signed char    RayRightAlpha;
_RayRightAlpha:		    .dsb 1
; static unsigned char  RayCurrentWall;
_RayCurrentWall:		.dsb 1
; static unsigned char  RayIdXPoint1, RayIdXPoint2;
_RayIdXPoint1:		    .dsb 1
_RayIdXPoint2:		    .dsb 1
; static unsigned char  RaySliceIdx;
_RaySliceIdx:		    .dsb 1
; static unsigned int   RayDistance;
_RayDistance:		    .dsb 2
; static signed char    InterpAngleLeft;
_InterpAngleLeft:		.dsb 1
; static signed char    InterpAngleRight;
_InterpAngleRight:		.dsb 1
; static unsigned char  InterpIdxLeft;
_InterpIdxLeft:		    .dsb 1
; static unsigned char  RayNbSlice;
_RayNbSlice:		    .dsb 1
; static unsigned int   RayWallLog;
_RayWallLog:            .dsb 2

#endif // USE_ASM_RAYCASTING_DATA




#ifdef USE_ASM_TOTO
;; void toto() {
_toto:
.(
    ;; RayAlpha        = InterpAngleLeft;
    ;; RaySliceIdx     = InterpIdxLeft;
    ;; if (RayNbSlice == 0) return;

    lda _InterpAngleLeft
    sta _RayAlpha
    lda _InterpIdxLeft
    sta _RaySliceIdx
    lda _RayNbSlice
    bne RayNbSliceNotNull
    jmp toto_done
RayNbSliceNotNull:

RayLoop:
    ;; while(1){
        ;; // RayDistance = longexp(RayDistance);
        ;; RayDistance = RayWallLog + (unsigned int)tab_denom[(unsigned char)RayAlpha];
        ldy _RayAlpha;
        lda (_tab_denom),Y;
        clc
        adc _RayWallLog;
        sta _RayDistance;
        lda _RayDistance+1;
        adc #0;
        sta _RayDistance+1;


        // if (rayzbuffer[RaySliceIdx] > RayDistance){
        //      rayzbuffer[RaySliceIdx] = RayDistance;
        //      raywall[RaySliceIdx] = RayCurrentWall;
        // }

        ldy _RaySliceIdx
        lda _rayzbuffer,Y
        clc
        sbc _RayDistance
        bcc raycloserwall
            lda _RayDistance
            sta _rayzbuffer,Y
            lda _RayCurrentWall
            sta _raywall,Y
raycloserwall:

        // RaySliceIdx += 1;
        inc _RaySliceIdx

        // RayAlpha-=SLICE_ANGULAR_INCREMENT;
        lda _RayAlpha
        sec
        sbc #2 ;; FIXME .. USE A defined constant
        sta _RayAlpha

        // if ((--RayNbSlice) == 0) break;
        dec _RayNbSlice
        beq  toto_done

    jmp RayLoop
    ;; }
toto_done:
    rts
.)
#endif USE_ASM_TOTO

#ifdef USE_ASM_PREDRAW
; void preDraw()
_preDraw:
.(
    ldy _RayCurrentWall
    lda _lWallsCosBeta,Y
    bne OxAlignedWall

    ldy _RayIdXPoint1
    lda _lPointsX,Y
    sec
    sbc _rayCamPosX
    bpl PositivOyDeltaWithWall
    eor #$FF
    clc
    adc #1
    PositivOyDeltaWithWall
    tay
    lda _log2_tab,Y
    sta _RayWallLog

    lda #<(_tab_1overcos)
    sta _tab_denom
    lda #>(_tab_1overcos)
    sta _tab_denom+1


    jmp predrawDone
OxAlignedWall:
    ldy _RayIdXPoint1
    lda _lPointsY,Y
    sec
    sbc _rayCamPosY
    bpl PositivOxDeltaWithWall
    eor #$FF
    clc
    adc #1
    PositivOxDeltaWithWall
    tay
    lda _log2_tab,Y
    sta _RayWallLog

    lda #<(_tab_1oversin)
    sta _tab_denom
    lda #>(_tab_1oversin)
    sta _tab_denom+1

predrawDone:
    rts
.)


#ifdef USE_ASM_RAYCASTING
;; static void drawLeftCuttingWall1Visible(){
_drawLeftCuttingWall1Visible:
.(    
    ;; preDraw();
    ;; InterpAngleLeft=RayLeftAlpha;
    ;; InterpAngleRight=lAngle[RayIdXPoint1]+ rayCamRotZ;
    ;; InterpIdxLeft = 0; 
    ;; RayNbSlice = (((InterpAngleLeft - InterpAngleRight)&0xFF) >> 1)+1;
    ;; toto();

        jsr _preDraw;
    ;; InterpAngleLeft=RayLeftAlpha;   
        lda _RayLeftAlpha;
        sta _InterpAngleLeft;

    ;; InterpAngleRight=lAngle[RayIdXPoint1]+ rayCamRotZ;
        ldy _RayIdXPoint1;
        lda _lAngle,Y;
        clc;
        adc _rayCamRotZ;
        sta _InterpAngleRight;

    ;; InterpIdxLeft = 0; 
        lda #0;
        sta _InterpIdxLeft;

    ;; RayNbSlice = (((InterpAngleLeft - InterpAngleRight)&0xFF) >> 1)+1;
        lda _InterpAngleLeft;
        sec;
        sbc _InterpAngleRight;
        lsr;
        clc;
        adc #1;
        sta _RayNbSlice;

        jsr _toto;


    rts
.)

; static void drawLeftCuttingWall2Visible(){
_drawLeftCuttingWall2Visible:
.(
    ;; preDraw();
    ;; InterpAngleLeft=RayLeftAlpha;
    ;; InterpAngleRight=lAngle[RayIdXPoint2]+ rayCamRotZ;
    ;; InterpIdxLeft = 0; 
    ;; RayNbSlice = (((InterpAngleLeft - InterpAngleRight)&0xFF) >> 1)+1;
    ;; toto();

        jsr _preDraw;

    // InterpAngleLeft=RayLeftAlpha;
        lda _RayLeftAlpha;
        sta _InterpAngleLeft;

    // InterpAngleRight=lAngle[RayIdXPoint2]+ rayCamRotZ;
        ldy _RayIdXPoint2;
        lda _lAngle,Y;
        clc;
        adc _rayCamRotZ;
        sta _InterpAngleRight;

    // InterpIdxLeft = 0; 
        lda #0;
        sta _InterpIdxLeft;

    // RayNbSlice = (((InterpAngleLeft - InterpAngleRight)&0xFF) >> 1)+1;
        lda _InterpAngleLeft;
        sec;
        sbc _InterpAngleRight;
        lsr;
        clc;
        adc #1;
        sta _RayNbSlice;

        jsr _toto;

    rts
.)

; static void drawRightCuttingWall1Visible(){
_drawRightCuttingWall1Visible:
.(
    ;; preDraw();
    ;; InterpIdxLeft = (SCREEN_WIDTH - lAngle[RayIdXPoint1]) >> 1;
    ;; InterpAngleLeft=lAngle[RayIdXPoint1]+rayCamRotZ;
    ;; InterpAngleRight=RayRightAlpha;
    ;; RayNbSlice = (((InterpAngleLeft - InterpAngleRight)&0xFF) >> 1)+1;
    ;; toto();
    
        jsr _preDraw;
        // InterpIdxLeft = (SCREEN_WIDTH - lAngle[RayIdXPoint1]) >> 1;
        ldy _RayIdXPoint1;
        lda #40;
        sec;
        sbc _lAngle,Y;
        lsr;
        sta _InterpIdxLeft;

        // InterpAngleLeft=lAngle[RayIdXPoint1]+rayCamRotZ;
        lda _rayCamRotZ;
        ldy _RayIdXPoint1;
        clc;
        adc _lAngle,Y;
        sta _InterpAngleLeft;

        // InterpAngleRight=RayRightAlpha;
        lda _RayRightAlpha;
        sta _InterpAngleRight;

        // RayNbSlice = (((InterpAngleLeft - InterpAngleRight)&0xFF) >> 1)+1;
        lda _InterpAngleLeft;
        sec;
        sbc _InterpAngleRight;
        lsr;
        clc;
        adc #1;
        sta _RayNbSlice;
        jsr _toto;

    rts
.)


;static void drawRightCuttingWall2Visible(){
_drawRightCuttingWall2Visible:
.(
    ;; preDraw();
    ;; InterpAngleLeft=lAngle[RayIdXPoint2]+rayCamRotZ;
    ;; InterpAngleRight=RayRightAlpha;
    ;; InterpIdxLeft = (SCREEN_WIDTH - lAngle[RayIdXPoint2]) >> 1;
    ;; RayNbSlice = (((InterpAngleLeft - InterpAngleRight)&0xFF) >> 1)+1;
    ;; toto();


        jsr _preDraw;

    // InterpAngleLeft=lAngle[RayIdXPoint2]+rayCamRotZ;
        lda _rayCamRotZ;
        ldy _RayIdXPoint2;
        clc;
        adc _lAngle,Y;
        sta _InterpAngleLeft;

    // InterpAngleRight=RayRightAlpha;
        lda _RayRightAlpha;
        sta _InterpAngleRight;

    // InterpIdxLeft = (SCREEN_WIDTH - lAngle[RayIdXPoint2]) >> 1;
        ldy _RayIdXPoint2;
        lda #40  ;; FIXME use a defined const instead of hard coded SCREEN_WIDTH
        sec;
        sbc _lAngle,Y;
        lsr;
        sta _InterpIdxLeft;

    // RayNbSlice = (((InterpAngleLeft - InterpAngleRight)&0xFF) >> 1)+1;
        lda _InterpAngleLeft;
        sec;
        sbc _InterpAngleRight;
        lsr;
        clc;
        adc #1;
        sta _RayNbSlice;


        jsr _toto;


    rts
.)


; static void drawFullCrossingWall(){
_drawFullCrossingWall:
.(
    ;; preDraw();

    jsr _preDraw

    ; InterpAngleLeft     =RayLeftAlpha;
    lda _RayLeftAlpha
    sta _InterpAngleLeft

    ; InterpAngleRight    =RayRightAlpha;
    lda _RayRightAlpha
    sta _InterpAngleRight

    ; RayNbSlice          = NB_SLICES;
    lda #40 ;; FIXME .. use a defined const 
    sta _RayNbSlice

    ; InterpIdxLeft       = 0;
    lda #0
    sta _InterpIdxLeft

    ;; toto();

    jsr _toto
    rts
.)


; static void drawFullVisibleWall(){
_drawFullVisibleWall:
.(
    ; preDraw();
    jsr _preDraw

    ; if (lAngle[RayIdXPoint1] > lAngle[RayIdXPoint2]){
    ldy _RayIdXPoint2
    lda _lAngle,Y
    ldy _RayIdXPoint1
    sec
    sbc  _lAngle,Y
    bpl Point1OnTheRight
    
        ; InterpIdxLeft = (SCREEN_WIDTH - lAngle[RayIdXPoint1]) >> 1;
        lda   #40 ;; FIXME Use NB_SLICE instead 
        ldy   _RayIdXPoint1
        sec
        sbc   _lAngle,Y
        lsr
        sta _InterpIdxLeft

        ; InterpAngleLeft=lAngle[RayIdXPoint1]+ rayCamRotZ;
        ldy         _RayIdXPoint1
        lda         _lAngle,Y 
        clc
        adc         _rayCamRotZ
        sta         _InterpAngleLeft

        ; InterpAngleRight=lAngle[RayIdXPoint2]+ rayCamRotZ; // TODO : remove me to save cycles
        ldy         _RayIdXPoint2
        lda         _lAngle,Y
        clc
        adc         _rayCamRotZ
        sta         _InterpAngleRight

        ; RayNbSlice = ((lAngle[RayIdXPoint1] - lAngle[RayIdXPoint2]) >> 1 )+1;
        ldy         _RayIdXPoint1
        lda         _lAngle,Y
        ldy         _RayIdXPoint2
        sec
        sbc         _lAngle,Y
        lsr
        clc
        adc         #1
        sta         _RayNbSlice


    jmp ReadyForToto
    ; } else {
Point1OnTheRight:
        ; InterpIdxLeft = (SCREEN_WIDTH - lAngle[RayIdXPoint2]) >> 1;
        lda         #40 ;; FIXME Use NB_SLICE instead 
        ldy         _RayIdXPoint2
        sec
        sbc         _lAngle,Y
        lsr
        sta _InterpIdxLeft


        ; InterpAngleLeft=lAngle[RayIdXPoint2]+ rayCamRotZ;
        ldy         _RayIdXPoint2       // TODO REMOVE ME to SAVE CYCLE
        lda         _lAngle,Y
        clc
        adc         _rayCamRotZ
        sta         _InterpAngleLeft

        ; InterpAngleRight=lAngle[RayIdXPoint1]+ rayCamRotZ; // TODO : remove me to save cycles
        ldy         _RayIdXPoint1
        lda         _lAngle,Y
        clc
        adc         _rayCamRotZ
        sta         _InterpAngleRight

        ; RayNbSlice = ((lAngle[RayIdXPoint2] - lAngle[RayIdXPoint1]) >> 1 )+1;
        ldy         _RayIdXPoint2
        lda         _lAngle,Y
        ldy         _RayIdXPoint1
        sec         
        sbc         _lAngle,Y
        lsr
        clc
        adc         #1
        sta _RayNbSlice

ReadyForToto:
    ; toto();
    jsr _toto
    rts
.)




#endif // USE_ASM_RAYCASTING




