
#ifndef __GNUC__
#define ADR_BASE_TEXT_SCREEN 0xbb80
#else
#ifndef USE_NCURSES
#define ADR_BASE_TEXT_SCREEN ((char*)screen_buffer)
#endif
#endif

#ifndef USE_NCURSES
char *getpos(unsigned x, unsigned y)
{
#ifdef USE_C_MULTI40
    return (char *)(ADR_BASE_TEXT_SCREEN + x + multi40[y]);
#else
    return (char *)(ADR_BASE_TEXT_SCREEN + x + 40*y);
#endif
}
#endif

#ifdef USE_C_PRINT_TEXT
void printText(char *text, unsigned char x, unsigned char y)
{

#ifdef USE_NCURSES
    mvaddstr(y, x, text);
#else

#ifdef USE_C_MULTI40
    void * dest_adr = (void *) (ADR_BASE_TEXT_SCREEN + x + multi40[y]);
    int nbCar = strlen(text);
    memcpy(dest_adr, text, nbCar);
#else
    memcpy((void *) (ADR_BASE_TEXT_SCREEN + x + 40*y), text, strlen(text));
#endif
#endif // USE_CURSES
}
#endif // USE_C_PRINT_TEXT

void printChar(char c, unsigned char x, unsigned char y)
{
#ifdef USE_NCURSES
    mvaddch(y, x, c);
#else

    char *screenPos;
    screenPos = (char *) getpos(x, y);
    *screenPos = c;
#endif // USE_NCURSES
}
